/************************/
/*     ClSocket.cpp     */
/************************/
#include "stdafx.h"
#include "Oki.h"
#include "ClSocket.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

/////////////////////////////////////////////////////////////////////////////
// CClSocket

CClSocket::CClSocket()
{
	open_flag = 0;
}

CClSocket::~CClSocket()
{
}


// ClassWizard KvƂȉ̍sҏWȂłB
#if 0
BEGIN_MESSAGE_MAP(CClSocket, CAsyncSocket)
	//{{AFX_MSG_MAP(CClSocket)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
#endif	// 0

/////////////////////////////////////////////////////////////////////////////
// CClSocket o֐

void CClSocket::OnConnect(int nErrorCode) 
{
	if (AsyncSelect(FD_READ | FD_CLOSE) == 0) 
	{
		open_flag = -1;
	}
	else
	{
		open_flag    = 1;
		if (parent)
		{
			::PostMessage(parent,WM_LAN,0,0);
		}
	}

	CAsyncSocket::OnConnect(nErrorCode);
}

void CClSocket::OnReceive(int nErrorCode) 
{
	if (parent)
	{
		::PostMessage(parent,WM_LAN,0,1);
	}

	CAsyncSocket::OnReceive(nErrorCode);
}

void CClSocket::OnClose(int nErrorCode) 
{
	open_flag = 0;

	Close();

	if (parent)
	{
		::PostMessage(parent,WM_LAN,0,2);
	}

	CAsyncSocket::OnClose(nErrorCode);
}
