/************************/
/*       Csa.cpp        */
/************************/
#include "stdafx.h"
#include <direct.h>
#include "sente.h"

/************************/
/* CSA vlDLL ` */
/************************/

typedef void(*CSA_INI)(int *cflag);
typedef int (*CSA_SIKOU)(int tesu,unsigned char kifu[][2],int *timer_sec,
									int *i_moto,int *i_saki,int *i_naru);
typedef void(*CSA_END)();

extern int				csa_run_flag;
extern int				chudan_flag;
extern int				tesu;
extern int				timer_sec[];
extern unsigned char	kifu[][2];

static HANDLE			hEvent;
static int				stop_flag;

/************************/
/* _~[[` */
/************************/

static void dummy_ini(int *c)
{
	//MessageBox("1`2099͈̔͂œ͂ĂB","JnN");
}

/**********************/
/* _~[vl[` */
/**********************/

static int dummy_sikou(int tesu,unsigned char kifu[][2],int *timer_sec,
									int *i_moto,int *i_saki,int *i_naru)
{
	MessageBox(NULL, "_~[vl[`łB", "", MB_YESNOCANCEL|MB_ICONWARNING);
	
	//sasu(men_h,teban,moto,saki,naru);
	return(0);
}

/**********************/
/* _~[I[` */
/**********************/

static void dummy_end()
{
	MessageBox(NULL, "_~[I[`łB", "", MB_YESNOCANCEL|MB_ICONWARNING);
}

static HINSTANCE	lib;
static CSA_INI		sikou_ini;
static CSA_SIKOU	sikou;
static CSA_END		sikou_end;
static char			filename[_MAX_PATH];

void ini_csa_dll()
{
	lib         = NULL;
	sikou_ini   = dummy_ini;
	sikou       = dummy_sikou;
	sikou_end   = dummy_end;
	filename[0] = 0;
}

/*********************/
/* DLLƃNB */
/*********************/

void set_csa_dll(CString m_dll,CString m_dir,CString m_ini,CString m_sikou,CString m_end,int flag)
{
	CSA_INI		ini_proc;
	CSA_SIKOU	sikou_proc;
	CSA_END		end_proc;
	char		dir_name[_MAX_PATH];

	strcpy_s(dir_name,m_dir);
	if (dir_name[0])
	{
		_chdir(dir_name);
	}

	if (flag)
	{
		if (lib)
		{
			if (strcmp(filename,m_dll))
			{
				FreeLibrary(lib);
				strcpy_s(filename,m_dll);
				if (filename[0])
				{
					lib = LoadLibrary(filename);
					if (lib)
					{
						ini_proc = (CSA_INI)GetProcAddress(lib,m_ini);
						if (ini_proc)
						{
							sikou_ini = ini_proc;
						}
						else
						{
							sikou_ini = dummy_ini;
						}
						sikou_proc = (CSA_SIKOU)GetProcAddress(lib,m_sikou);
						if (sikou_proc)
						{
							sikou = sikou_proc;
						}
						else
						{
							sikou = dummy_sikou;
						}
						end_proc = (CSA_END)GetProcAddress(lib,m_end);
						if (end_proc)
						{
							sikou_end = end_proc;
						}
						else
						{
							sikou_end = dummy_end;
						}
					}
					else
					{
						sikou_ini = dummy_ini;
						sikou     = dummy_sikou;
						sikou_end = dummy_end;
					}
				}
				else
				{
					lib       = NULL;
					sikou_ini = dummy_ini;
					sikou     = dummy_sikou;
					sikou_end = dummy_end;
				}
			}
			else
			{
				ini_proc = (CSA_INI)GetProcAddress(lib,m_ini);
				if (ini_proc)
				{
					sikou_ini = ini_proc;
				}
				else
				{
					sikou_ini = dummy_ini;
				}
				sikou_proc = (CSA_SIKOU)GetProcAddress(lib,m_sikou);
				if (sikou_proc)
				{
					sikou = sikou_proc;
				}
				else
				{
					sikou = dummy_sikou;
				}
				end_proc = (CSA_END)GetProcAddress(lib,m_end);
				if (end_proc)
				{
					sikou_end = end_proc;
				}
				else
				{
					sikou_end = dummy_end;
				}
			}
		}
		else
		{
			strcpy_s(filename,m_dll);
			if (filename[0])
			{
				lib = LoadLibrary(filename);
				if (lib)
				{
					ini_proc = (CSA_INI)GetProcAddress(lib,m_ini);
					if (ini_proc)
					{
						sikou_ini = ini_proc;
					}
					else
					{
						sikou_ini = dummy_ini;
					}
					sikou_proc = (CSA_SIKOU)GetProcAddress(lib,m_sikou);
					if (sikou_proc)
					{
						sikou = sikou_proc;
					}
					else
					{
						sikou = dummy_sikou;
					}
					end_proc = (CSA_END)GetProcAddress(lib,m_end);
					if (end_proc)
					{
						sikou_end = end_proc;
					}
					else
					{
						sikou_end = dummy_end;
					}
				}
				else
				{
					sikou_ini = dummy_ini;
					sikou     = dummy_sikou;
					sikou_end = dummy_end;
				}
			}
			else
			{
				lib       = NULL;
				sikou_ini = dummy_ini;
				sikou     = dummy_sikou;
				sikou_end = dummy_end;
			}
		}
	}
	else
	{
		strcpy_s(filename,m_dll);
		if (filename[0])
		{
			lib = LoadLibrary(filename);
			if (lib)
			{
				ini_proc = (CSA_INI)GetProcAddress(lib,m_ini);
				if (ini_proc)
				{
					sikou_ini = ini_proc;
				}
				else
				{
					sikou_ini = dummy_ini;
				}
				sikou_proc = (CSA_SIKOU)GetProcAddress(lib,m_sikou);
				if (sikou_proc)
				{
					sikou = sikou_proc;
				}
				else
				{
					sikou = dummy_sikou;
				}
				end_proc = (CSA_END)GetProcAddress(lib,m_end);
				if (end_proc)
				{
					sikou_end = end_proc;
				}
				else
				{
					sikou_end = dummy_end;
				}
			}
			else
			{
				sikou_ini = dummy_ini;
				sikou     = dummy_sikou;
				sikou_end = dummy_end;
			}
		}
		else
		{
			lib       = NULL;
			sikou_ini = dummy_ini;
			sikou     = dummy_sikou;
			sikou_end = dummy_end;
		}
	}
}

/*******************/
/* DLLB */
/*******************/

void free_csa_dll()
{
	if (lib)
	{
		FreeLibrary(lib);
	}
}

static UINT CsaThreadProc(LPVOID pParam)
{
	int		moto;
	int		saki;
	int		naru;
	int		teban;
	int		kotae;

	csa_run_flag = 1;
	stop_flag = 0;
	sikou_ini(&chudan_flag);
	while(1)
	{
		WaitForSingleObject(hEvent,INFINITE);
		if (stop_flag)break;
		if (chudan_flag)break;
		teban = tesu & 0x0001;
		kotae = sikou(tesu,kifu,timer_sec,&moto,&saki,&naru);
		switch(kotae)
		{
		case 0:		// 
			::PostMessage((HWND)pParam,WM_SASITE,0,-1);
			break;
		case -1:	// (Not define)
		case -2:	// ҂(Not define)
		case -3:	// f(Not define)
			::PostMessage((HWND)pParam,WM_SASITE,0,kotae);
			break;
		case -4:	// 錾
			::PostMessage((HWND)pParam,WM_SASITE,0,-4);
			break;
		case -5:	// 錾
			::PostMessage((HWND)pParam,WM_SASITE,0,-5);
			break;
		default:
			if (naru)
			{
				saki += NARU_CODE;
			}
			::PostMessage((HWND)pParam,WM_SASITE,moto,saki);
			break;
		}
	}
	sikou_end();
	CloseHandle(hEvent);
	csa_run_flag = 0;
	return(0);
}

void csa_start(HWND m_hWnd)
{
	if (csa_run_flag)return;
	hEvent = CreateEvent(NULL,FALSE,FALSE,NULL);
	AfxBeginThread(CsaThreadProc,m_hWnd,THREAD_PRIORITY_NORMAL);
}

void csa_kick()
{
	SetEvent(hEvent);
}

void csa_stop()
{
	stop_flag = 1;
	SetEvent(hEvent);
}

