/************************/
/*     ShiroDlg.cpp     */
/************************/
#include "stdafx.h"
#include "Oki.h"
#include "ShiroDlg.h"
#include "sente.h"

extern void	strcopy(char *s1,char *s2);
extern void	strcat2(char *s1,char *s2);

extern char	hkyokumen[];
extern char	Current_Dir[];

typedef struct
{
    char    sman[12];                   /* ΋ǎ */
    short   kyoku;                      /*          */
    char    gman[12];                   /* ΋ǎ */
	short	teai;						/* 荇     */
    short   nen;                        /* N         */
    short	tsuki;                      /*          */
    short	hi;                         /*          */
    short	kachi;                      /* s@@@ */
	short	kisen;						/* 햼     */
    short	senkei;                     /* ^       */
}IDX_S;

typedef struct
{
    int		kensu;                      /* o^   */
    int		yobi[9];
}DIR_S;

static char *kachi_moji[] = { "so^" , "菟" , "菟" ,
                              ""    , ""   , "ȉ菟" ,
                              "ȉ菟","ȉ","ȉ" };
static char *kachi_moji2[]= { "so^" , "菟" , "菟" ,
                              ""    , ""   , "ȉ菟" ,
                              "ȉ菟","ȉ","ȉ" };
static char *teai_moji[] = { "" , "" , "p" ,
                             "ԗ" , "򍁗" , "񖇗" ,
                             "l" , "Z" , "" ,
                             "\" , "" };
static char *prog_moji[] = 
	{ "@" , "^@" , "w" , "ǁ@@" , "s@" , "萔@" , "荇" , "wQ" } ;
static char    *sansuji[]  = { "P","Q","R","S","T","U","V","W","X"};
static char    *kansuji[]  = { "","","O","l","","Z","","",""};
static char    *komamoji[] = { "@","",""  ,"j"  ,""  ,"","p",""
                              ,"","","","j","","","n",""};

/////////////////////////////////////////////////////////////////////////////
// CShiroDlg _CAO

IMPLEMENT_DYNAMIC(CShiroDlg,CDialog)

CShiroDlg::CShiroDlg(int shiro_prog2,int shiro_prog3,
					 int prog,char *kmen,CWnd* pParent /*=NULL*/)
	: CDialog(CShiroDlg::IDD, pParent)
{
	m_static1 = _T("");
	m_list = _T("");

	kensaku_men  = kmen;
	prog2        = shiro_prog2;
	prog3        = shiro_prog3;
	kensaku_prog = prog;
	gyaku_flag   = 1;
}

void CShiroDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Text(pDX, IDC_STATIC1, m_static1);
	DDX_LBString(pDX, IDC_SHIRO_LIST, m_list);
}

BEGIN_MESSAGE_MAP(CShiroDlg, CDialog)
	ON_BN_CLICKED(IDC_BUTTON_JOHO1, OnButtonJoho1)
	ON_BN_CLICKED(IDC_BUTTON_JOHO2, OnButtonJoho2)
	ON_WM_VSCROLL()
	ON_LBN_DBLCLK(IDC_SHIRO_LIST, OnDblclkShiroList)
	ON_BN_CLICKED(IDC_BUTTON_NEW, OnButtonNew)
	ON_BN_CLICKED(IDC_BUTTON_SAKUJO, OnButtonSakujo)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CShiroDlg bZ[W nh

/****************/
/* f[^ */
/****************/
BOOL CShiroDlg::shiro2(char* mess ,char* ks_name,int* data_su)
{
    FILE        *fp;
    int         i;
	char		filename[_MAX_PATH];

    /* Rt@Cݒ */
    shiro_name = ks_name;

    if (*data_su == 0)
    {
    	sprintf_s(filename,"%s.MIX",shiro_name);
    	fopen_s(&fp,filename,"rb");
		if (fp)
		{
	  		fread(&max,1,4,fp);
			fclose(fp);
		}

		sprintf_s(filename,"%s\\.DAT",Current_Dir);
        fopen_s(&fp,filename,"wb");
        for (i = 1 ; i <= max ; i++)
        {
            fwrite(&i,1,4,fp);
        }
        fclose(fp);
        *data_su = max;
    }
    else
    {
        max = *data_su;
    }

    if (max <= 0)
    {
        strcopy(mess,"\Ώۃf[^܂B");
        return(TRUE);
    }
	else
	{
		ip = 0;
		return(FALSE);
	}
}

BOOL CShiroDlg::OnInitDialog() 
{
	CScrollBar*	pSB = (CScrollBar*)GetDlgItem(IDC_SHIRO_BAR);
	int			nmax;
	char		moji[80];
	char		kisen_moji [100][20];
	char		senkei_moji[100][16];

	sprintf_s(moji," ԍ                     ΋Ǔ  %-8s @@@@%s"
							,prog_moji[prog2],prog_moji[prog3]);
	m_static1 = moji;

	get_senkei(senkei_moji);
	get_kisen (kisen_moji);
	data_disp(senkei_moji,kisen_moji);

	nmax = max - 20;
	if (nmax < 0)nmax = 0;
	pSB->SetScrollRange(0,nmax);
	pSB->SetScrollPos  (ip);

	return	CDialog::OnInitDialog();
}

/**************/
/* 햼擾 */
/**************/
void CShiroDlg::get_kisen(char kisen_moji[][20])
{
    int     i;
    char    moji[80];
	char	filename[_MAX_PATH];
    FILE    *fp;

    for (i = 0 ; i < 100 ; i++)
    {
        kisen_moji[i][0] = 0;
    }
	sprintf_s(filename,"%s\\.DAT",Current_Dir);
    fopen_s(&fp,filename,"r");
    if (fp == NULL)return;
    while(fgets(moji,sizeof(moji),fp))
    {
        i = atoi(moji);
        if (i <= 0)continue;
        if (i >= 100)continue;
        last_space_cut(&moji[3]);
        get_moji(&kisen_moji[i][0],&moji[3],16);
    }
    fclose(fp);
}

/**************/
/* ^擾 */
/**************/
void CShiroDlg::get_senkei(char senkei_moji[][16])
{
    int     i;
    char    moji[80];
	char	filename[_MAX_PATH];
    FILE    *fp;

    for (i = 0 ; i < 100 ; i++)
    {
        senkei_moji[i][0] = 0;
    }
	sprintf_s(filename,"%s\\^.DAT",Current_Dir);
    fopen_s(&fp,filename,"r");
    if (fp == NULL)return;
    while(fgets(moji,sizeof(moji),fp))
    {
        i = atoi(moji);
        if (i <= 0)continue;
        if (i >= 100)continue;
        last_space_cut(&moji[4]);
        get_moji(&senkei_moji[i][0],&moji[4],14);
    }
    fclose(fp);
}

/********************************/
/* Ō̃Xy[XJbgB */
/********************************/
int CShiroDlg::last_space_cut(char *s)
{
    int     i;
    int     llen;

    i = llen = 0;

    while(s[i])
    {
        if(s[i] == ' ')
        {
            i++;
        }
        else if(s[i] == '\n')
        {
            break;
        }
        else if (strncmp(&s[i],"@",2) == 0)
        {
            i += 2;
        }
        else if (moji_size(s[i]) == 2)
        {
            i   += 2;
            llen = i;
        }
        else
        {
            i++;
            llen = i;
        }

    }
    s[llen] = 0;
    return(llen);
}

/**************/
/* 擾 */
/**************/
void CShiroDlg::get_moji(char* s2,char* s1,int max)
{
    int    len;
    int    iend;

    len  = 0;
    iend = 1;

    while(iend)
    {
        switch(moji_size(*s1))
        {
        case 1:
            if (len >= max)
            {
                iend = 0;
                break;
            }
            *s2++ = *s1++;
            len++;
            break;
        case 2:
            if ((len + 1) >= max)
            {
                iend = 0;
                break;
            }
            *s2++ = *s1++;
            *s2++ = *s1++;
            len += 2;
            break;
        default:
            iend = 0;
            break;
        }
    }
    *s2 = 0;
}

int CShiroDlg::moji_size(char c1)
{
	unsigned char	c;

	c = (unsigned char)c1;
    if (c < 0x0020)return(0);
    if (c < 0x007f)return(1);
    if (c < 0x0081)return(0);
    if (c < 0x00a0)return(2);
    if (c < 0x00a1)return(0);
    if (c < 0x00e0)return(1);
    if (c < 0x00fd)return(2);
    return(0);
}

/**************/
/* f[^\ */
/**************/
void CShiroDlg::data_disp(char senkei_moji[][16],char kisen_moji[][20])
{
    FILE    *fp;
	FILE	*fpi;
	FILE	*fpk;
    int     i;
    long    npos;
	int		kyoku;
	int		teai;
	int		max_x;
    int     recno[20];
	char	filename[_MAX_PATH];
    char    moji[100];
    char    sente[16];
    char    gote[16];
    char    moji2[20];
    char    moji3[20];
	IDX_S	idx;
	CListBox* pLB_list = (CListBox*)GetDlgItem(IDC_SHIRO_LIST);

	pLB_list->ResetContent();

	sprintf_s(filename,"%s.MIX",shiro_name);
	fopen_s(&fpi,filename,"rb");
 
 	sprintf_s(filename,"%s.MKF",shiro_name);
	fopen_s(&fpk,filename,"rb");

	sprintf_s(filename,"%s\\.DAT",Current_Dir);
    fopen_s(&fp,filename,"rb");
	if (gyaku_flag == 0)
	{
    	npos = ip;
    	npos *= 4;
    	fseek(fp,npos,SEEK_SET);
		max_x = 0;
    	for (i = 0 ; i < 20 ; i++)
    	{
        	if (fread(&recno[i],1,4,fp) == 0)break;
        	if (recno[i] <= 0)break;
        	max_x++;
    	}
	}
	else
	{
    	npos = max - ip - 1;
    	npos *= 4;
		max_x = 0;
    	for (i = 0 ; i < 20 ; i++)
    	{
			fseek(fp,npos,SEEK_SET);
        	if (fread(&recno[i],1,4,fp) == 0)break;
        	if (recno[i] <= 0)break;
        	max_x++;
			npos -= 4;
			if (npos < 0)break;
    	}
	}
    fclose(fp);

    for (i = 0 ; i < max_x ; i++)
    {
        npos  = recno[i];
        npos *= 40;
        fseek(fpi,npos,SEEK_SET);
        fread(idx.sman,2,20,fpi);
		kyoku = idx.kyoku;
		idx.kyoku = 0;
        strcopy(sente,idx.sman);
		teai = idx.teai;
		idx.teai = 0;
        strcopy(gote ,idx.gman);

		get_inf(moji2,prog2,recno[i],idx.senkei,idx.kisen,teai,kyoku,
					idx.kachi,fpk,senkei_moji,kisen_moji);
		get_inf(moji3,prog3,recno[i],idx.senkei,idx.kisen,teai,kyoku,
					idx.kachi,fpk,senkei_moji,kisen_moji);
        sprintf_s(moji,"%6d %-12s %-12s %02d/%2d/%2d %-16s %s"
                        ,recno[i],sente,gote
                        ,idx.nen % 100,idx.tsuki,idx.hi
                        ,moji2,moji3);
		pLB_list->InsertString(-1,moji);
    }
	fclose(fpi);
	fclose(fpk);
}

void CShiroDlg::get_inf(char *moji,int prog,int recno,int senkei_no,int kisen_no,int teai,
						int kyoku,int kachi,FILE *fpk,char senkei_moji[][16],char kisen_moji[][20])
{
	long			npos;
	unsigned char	kifu[257][2];
	int				tesu;
	int				len;

    switch (prog)
    {
	case 0:                         	// 
    	get_moji(moji,&kisen_moji[kisen_no][0],16);
        break;
	case 1:								// ^
	    get_moji(moji,&senkei_moji[senkei_no][0],16);
		break;
    case 2:                         	// w
        npos  = recno - 1;
        npos *= 512;
        fseek(fpk,npos,SEEK_SET);
        fread(kifu,2,256,fpk);
        shirooki(kifu);
        tesu = ruiji(kifu,teai);
		kifuout(tesu,moji,kifu);
        break;
	case 3:                         	// 
        if (kyoku == 0)
        {
        	moji[0] = 0;
        }
        else
        {
        	sprintf_s(moji,100,"%2d",kyoku);
        }
        break;
    case 4:								// s
		if (teai == 0)
		{
			strcopy(moji,kachi_moji[kachi]);
		}
		else
		{
			strcopy(moji,kachi_moji2[kachi]);
		}
        break;
    case 5:								// 萔
        npos  = recno - 1;
        npos *= 512;
        fseek(fpk,npos,SEEK_SET);
        fread(kifu,2,256,fpk);
        kifu[256][0] = 0;
        len = strlen((char *)kifu) / 2;
		if (teai > 0)len--;
        sprintf_s(moji,100,"%4d",len);
        break;
	case 6:								// 荇
		strcopy(moji,teai_moji[teai]);
		break;
    default:                         	// wQ
        npos  = recno - 1;
        npos *= 512;
        fseek(fpk,npos,SEEK_SET);
        fread(kifu,2,256,fpk);
        shirooki(kifu);
        tesu = ruiji(kifu,teai) + 1;
		kifuout(tesu,moji,kifu);
        break;
	}
}

/*********************************************************************/
/*                                                                   */
/*           Rf[^\\\Bf[^ϊ    @uPDOO    */
/*                                                                   */
/*           @\@@F@Rf[^Bf[^ɕϊB          */
/*                                                                   */
/*           쐬ҁ@F@{q(SAF53393 & GCA02313 & TORA0332)    */
/*                                                                   */
/*           쐬@F@OVNPQQT                      */
/*                                                                   */
/*-------------------------------------------------------------------*/
/*                                                                   */
/*           ύXPF@    N                              */
/*                                                                   */
/*           ύX_PF                @@@@@@@                */
/*                                                                   */
/*********************************************************************/

int CShiroDlg::shirooki(unsigned char kifu[][2])
{
    int         tesu;

    /*  */
    kifu[256][0] = 0;
	if (kifu[0][0] == 255)
	{
		tesu = 1;
	}
	else
	{
		tesu = 0;
	}

    /* R[hϊ */
    while(kifu[tesu][0])
    {
		if(kifu[tesu][0] > 100)kifu[tesu][0] -= 28;
		if(kifu[tesu][1] > 100)kifu[tesu][1] -= 28;
		tesu++;
	}
    return(tesu);
}

/*********************************************************************/
/*                                                                   */
/*           ގǖʃ`FbN@@uPDOO@@@@@ @@       */
/*                                                                   */
/*           @\@@F@BR[hގǖʂ܂ł̎萔ԂB*/
/*                                                                   */
/*           쐬ҁ@F@{q(SAF53393 & GCA02313 & TORA0332)    */
/*                                                                   */
/*           쐬@F@OVNPQQT                      */
/*                                                                   */
/*-------------------------------------------------------------------*/
/*                                                                   */
/*           ύXPF@    N                              */
/*                                                                   */
/*           ύX_PF@@@@@@@@@@@@@@@                */
/*                                                                   */
/*********************************************************************/

int CShiroDlg::ruiji(unsigned char kifu[][2],int teai)
{
    int         i;
    int         ichi_new;
    int         ichi_old;
	char        men[100];
    char        s_men[82];
    int         koma;
	int			teban_flag;

    /* VXep[^`FbN */
	memcpy(men,hkyokumen,100);
	switch (teai)
	{
	case 0:								// 
		teban_flag = 0;
		break;
	case 1:								// 
		K11 = 0;
		teban_flag = 1;
		break;
	case 2:								// p
		K22 = 0;
		teban_flag = 1;
		break;
	case 3:								// 򗎂
		K82 = 0;
		teban_flag = 1;
		break;
	case 4:								// 򍁗
		K11 = K82 = 0;
		teban_flag = 1;
		break;
	case 5:								// 񖇗
		K22 = K82 = 0;
		teban_flag = 1;
		break;
	case 6:								// l
		K11 = K91 = K22 = K82 = 0;
		teban_flag = 1;
		break;
	case 7:								// Z
		K11 = K21 = K81 = K91 = K22 = K82 = 0;
		teban_flag = 1;
		break;
	case 8:								// 
		K11 = K21 = K31 = K71 = K81 = K91 = K22 = K82 = 0;
		teban_flag = 1;
		break;
	case 9:								// \
		K11 = K21 = K31 = K41 = K61 = K71 = K81 = K91 = K22 = K82 = 0;
		teban_flag = 1;
		break;
	default:							// 
		for (i = 1 ; i <= 27 ; i++)
		{
			men[i] = 0;
		}
		K51 = GOU;
		teban_flag = 1;
		break;
	}
    if (kensaku_prog == 0)return(teban_flag);
    memcpy(s_men,kensaku_men,82);

    /* ۂɊȂׂĂ݂B */
    for (i = teban_flag ; i < 256 ; i++)
    {
        if (kensaku_prog == 3)          /* ǖʌ */
        {
            if (memcmp(men,s_men,82) == 0)
            {
                return(i);
            }
        }
        else                            /* ގǖʌ */
        {
            if (banmen_check(s_men,men) == 0)
            {
                return(i);
            }
        }
        ichi_new = kifu[i][0] % 100;
        if (ichi_new == 0)break;
        ichi_old = kifu[i][1];
        if (ichi_old <= 100)
        {
            koma = men[ichi_old];
            men[ichi_old] = 0;
            if (kifu[i][0] > 100)
            {
                if (koma > 0)
                {
                    koma |= 0x08;
                }
                else if (koma > -8)
                {
                    koma -= 8;
                }
            }
            men[ichi_new] = koma;
        }
        else
        {
            if ((i & 0x01) == 0)
            {
				men[ichi_new] = ichi_old - 100;
            }
            else
            {
				men[ichi_new] = 100 - ichi_old;
            }
        }
    }
    return(teban_flag);
}

/**********************************************************************/
/*                                                                    */
/*   @\      @F@RvZ[`                             */
/*                                                                    */
/*         @F@{q(GCA02313 & TORA0332 & SAF53393)         */
/*                                                   type         i/o */
/*   p[^@F@tesu  萔iO琔Bj    int           i  */
/*                   kifu  RR[h          char[256][2]  i  */
/*                   cmoji o͊                  char[18]      o  */
/*                                                                    */
/**********************************************************************/
void CShiroDlg::kifuout(int tesu,char *cmoji,unsigned char kifu[][2])
{
	char        imen[100];
	char		*hmen;
    char        ban[100];
	int			teai;
    int         men_kifu[9][9];
    int         ix;
    int         iy;
    int         mochi[2][8];
    int         teban;
    int         koma;
    int         te;
    int         i_old;
    int         i_new;
    int         ix_old;
    int         iy_old;
    int         ix_new;
    int         iy_new;
    int         i_naru;
    int         i_mae;
	int			teban_flag;
    int         koma_old;
    int         i;

	if (kifu[0][0] == 255)
	{
		teai = kifu[0][1];
	}
	else
	{
		teai = 0;
	}

	memcpy(imen,hkyokumen,100);
	switch (teai)
	{
	case 0:								// 
		teban_flag = 0;
		break;
	case 1:								// 
		imen[P11] = 0;
		teban_flag = 1;
		break;
	case 2:								// p
		imen[P22] = 0;
		teban_flag = 1;
		break;
	case 3:								// 򗎂
		imen[P82] = 0;
		teban_flag = 1;
		break;
	case 4:								// 򍁗
		imen[P11] = imen[P82] = 0;
		teban_flag = 1;
		break;
	case 5:								// 񖇗
		imen[P22] = imen[P82] = 0;
		teban_flag = 1;
		break;
	case 6:								// l
		imen[P11] = imen[P91] = imen[P22] = imen[P82] = 0;
		teban_flag = 1;
		break;
	case 7:								// Z
		imen[P11] = imen[P21] = imen[P81] = imen[P91] = imen[P22] = imen[P82] = 0;
		teban_flag = 1;
		break;
	case 8:								// 
		imen[P11] = imen[P21] = imen[P31] = imen[P71] = imen[P81] = imen[P91] = imen[P22] = imen[P82] = 0;
		teban_flag = 1;
		break;
	case 9:								// \
		imen[P11] = imen[P21] = imen[P31] = imen[P41] = imen[P61] = imen[P71] = imen[P81] = imen[P91] = imen[P22] = imen[P82] = 0;
		teban_flag = 1;
		break;
	default:							// 
		for (i = 1 ; i <= 27 ; i++)
		{
			imen[i] = 0;
		}
		imen[P51]  = GOU;
		teban_flag = 1;
		break;
	}

	/* o͕ */
    strcopy(cmoji,"                ");
    if (tesu < teban_flag)return;

	/* ǖʏ */
    memcpy(ban,imen,100);
    hmen = ban + 1;
    for (iy = 0 ; iy < 9 ; iy++)
    {
        for (ix = 0 ; ix < 9 ; ix++)
        {
            men_kifu[ix][iy] = *hmen++;
        }
    }

	/* 䏉 */
    for (teban = 0 ; teban < 2 ; teban++)
    {
        for (koma = 0 ; koma < 8 ; koma++)
        {
            mochi[teban][koma] = *hmen++;
        }
    }

	/* w萔̈O܂ŕׂB */
    i_new = -1;
    for (te = teban_flag ; te < tesu ; te++)
    {
        teban = te & 0x01;
        i_new = kifu[te][0];
        if (i_new == 0)return;
        if (i_new > 100)
        {
            i_naru = 1;
            i_new -= 100;
        }
        else
        {
            i_naru = 0;
        }
        i_new--;
        ix_new = i_new % 9;
        iy_new = i_new / 9;

        i_old = kifu[te][1];
        if (i_old < 100)
        {
            i_old--;
            ix_old = i_old % 9;
            iy_old = i_old / 9;
        }

	/* Vʒű */
        koma = men_kifu[ix_new][iy_new];
        if (koma > 0)
        {
            koma &= 0x07;
            mochi[1][koma]++;
        }
        else if (koma < 0)
        {
            koma = (-koma) & 0x07;
            mochi[0][koma]++;
        }

	/* Âʒű̎ނ𓾂B */
        if (i_old > 100)
        {
            koma = i_old - 100;
			mochi[teban][koma]--;
            if(teban == 1)koma = -koma;
        }
        else
        {
            koma = men_kifu[ix_old][iy_old];
            men_kifu[ix_old][iy_old] = 0;
            if (i_naru == 1)
            {
                if (teban == 0)
                {
                    if (koma > 8)
                    {
                        i_naru = 0;
                    }
                    else
                    {
                        koma += 0x08;
                    }
                }
                else
                {
                    if (koma < -8)
                    {
                        i_naru = 0;
                    }
                    else
                    {
                        koma -= 8;
                    }
                }
            }
        }
        men_kifu[ix_new][iy_new] = koma;
    }

/*********************/
/* ǖʂZ[uB*/
/*********************/
    i_mae = i_new;
    teban = tesu & 0x01;
    if (teban == 0)
    {
        for (ix = 0; ix < 9 ; ix++)
        {
            for (iy = 0 ; iy < 9 ; iy++)
            {
                men_kifu2[ix][iy] = men_kifu[ix][iy];
            }
        }
    }
    else
    {
        for (ix = 0; ix < 9 ; ix++)
        {
            for (iy = 0 ; iy < 9 ; iy++)
            {
                men_kifu2[8 - ix][8 - iy] = -men_kifu[ix][iy];
            }
        }
    }

/**************************/
/* ῗB */
/**************************/
    i_new = kifu[te][0];
    if (i_new == 0)return;
    if (teban == 0)
    {
        strcopy(cmoji,"");
    }
    else
    {
        strcopy(cmoji,"");
    }
    if (i_new > 100)
    {
        i_naru = 1;
        i_new -= 100;
    }
    else
    {
        i_naru = 0;
    }
    i_new--;
    ix_new = i_new % 9;
    iy_new = i_new / 9;
    strcopy(&cmoji[2],sansuji[ix_new]);
    strcopy(&cmoji[4],kansuji[iy_new]);
    if (i_mae == i_new)
    {
        strcopy(&cmoji[2],"@");
    }
    i_old = kifu[te][1];
    if (i_old < 100)
    {
       i_old--;
       ix_old = i_old % 9;
       iy_old = i_old / 9;
    }

	/* Vʒű */
    koma = men_kifu[ix_new][iy_new];
    if (koma > 0)
    {
        koma &= 0x07;
        mochi[1][koma]++;
    }
    else if (koma < 0)
    {
        koma = (-koma) & 0x07;
        mochi[0][koma]++;
    }

	/* Âʒű̎ނ𓾂B */
    if (i_old > 100)
    {
		koma = i_old - 100;
        mochi[teban][koma]--;
        koma_old = koma;
        if(teban == 1)koma = -koma;
    }
    else
    {
        koma = men_kifu[ix_old][iy_old];
        if (koma > 0)
        {
            koma_old = koma;
        }
        else
        {
            koma_old = -koma;
        }
        men_kifu[ix_old][iy_old] = 0;
        if (i_naru == 1)
        {
            if (teban == 0)
            {
                if (koma > 8)
                {
                    i_naru = 0;
                }
                else
                {
                    koma += 0x08;
                }
            }
            else
            {
                if (koma < -8)
                {
                    i_naru = 0;
                }
                else
                {
                    koma -= 8;
                }
            }
        }
    }
    strcat2(cmoji,komamoji[koma_old]);
    men_kifu[ix_new][iy_new] = koma;
    if(teban == 1)
    {
        ix_new = 8 - ix_new;
        iy_new = 8 - iy_new;
        ix_old = 8 - ix_old;
        iy_old = 8 - iy_old;
    }
    if(i_old > 100)
    {
        ix_old = -1;
        iy_old = koma_old;
    }
    fuki(cmoji,ix_new,iy_new,ix_old,iy_old,i_naru); /* */

	/* Œ蒷WɂB */
    for (i = 0; i < 16 ; i+= 2)
    {
        if(cmoji[i] == 0)
        {
            strcopy(&cmoji[i],"  ");
        }
    }
}

/********************************************/
/* Ֆʂ{Ăǖʂƈv邩ׂB */
/********************************************/
int CShiroDlg::banmen_check(char* p,char* k)
{
    int i;
    int kotae;

    kotae = 0;
    for (i = 1 ; i <= 81; i++)
    {
        if(p[i] == 0)continue;
        if(p[i] != k[i])
        {
            kotae = 1;
            break;
        }
    }
    if (kotae == 0)return(0);

	if (kensaku_prog == 2)return(-1);

    for (i = 1 ; i <= 81; i++)
    {
        if(p[i] == 0)continue;
        if(p[i] != (-k[82 - i]))
        {
            return(-1);
        }
    }
    return(0);
}

/*****************************/
/*  ̕tL\쐬B */
/*****************************/
void CShiroDlg::fuki(char *moji,int ix_new,int iy_new,int ix_old,int iy_old,int i_naru)
{
    int koma;

	/* ړ𔻒fB */
    if (ix_old < 0)
    {
        koma = iy_old;
    }
    else
    {
        koma = men_kifu2[ix_old][iy_old];
    }

	/* ʏ */
    switch(koma)
    {
    case 1:  /*  */
        naru_k(moji,iy_new,ix_old,iy_old,i_naru);
        break;
    case 2:  /*  */
        kyo(moji,ix_new,iy_new,ix_old,iy_old);
        naru_k(moji,iy_new,ix_old,iy_old,i_naru);
        break;
    case 3:  /* j */
        kei(moji,ix_new,iy_new,ix_old,iy_old);
        naru_k(moji,iy_new,ix_old,iy_old,i_naru);
        break;
    case 4:  /*  */
        gin(moji,ix_new,iy_new,ix_old,iy_old);
        naru_k(moji,iy_new,ix_old,iy_old,i_naru);
        break;
    case 5:  /*  */
    case 9:  /*  */
    case 10: /*  */
    case 11: /* j */
    case 12: /*  */
        kin(moji,ix_new,iy_new,ix_old,iy_old);
        break;
    case 6:  /* p */
        kaku(moji,ix_new,iy_new,ix_old,iy_old);
        naru_k(moji,iy_new,ix_old,iy_old,i_naru);
        break;
    case 7:  /*  */
        hisya(moji,ix_new,iy_new,ix_old,iy_old);
        naru_k(moji,iy_new,ix_old,iy_old,i_naru);
        break;
    case 14: /* n */
        uma(moji,ix_new,iy_new,ix_old,iy_old);
        break;
    case 15: /*  */
        ryu(moji,ix_new,iy_new,ix_old,iy_old);
        break;
    default:
        break;
    }
}

/******************************/
/* As̕\vZB */
/******************************/
void CShiroDlg::naru_k(char* moji,int iy_new,int ix_old,int iy_old,int i_naru)
{
    if (ix_old < 0)return;              /* ł */
    if ((iy_old >= 3) && (iy_new >= 3))return;
    if (i_naru == 1)
    {
        strcat2(moji,"");
    }
    else
    {
        strcat2(moji,"s");
    }
}

/*****************************/
/*  ̕tL\vZB */
/*****************************/
void CShiroDlg::kyo(char *moji,int ix_new,int iy_new,int ix_old,int iy_old)
{
    int iy;

	/* łȊÓAtLsv */
    if (ix_old >= 0)return;

	/* Տō̏ꏊɍs邩H */
    for (iy = iy_new + 1; iy < 9 ; iy++)
    {
        if (men_kifu2[ix_new][iy] == 2)
        {
            strcat2(moji,"");
        }
        if (men_kifu2[ix_new][iy] != 0)break;
    }
}

/*****************************/
/*  j̕tL\vZB */
/*****************************/

void CShiroDlg::kei(char *moji,int ix_new,int iy_new,int ix_old,int iy_old)
{
    int iy;
    int cnt;

	/* Q݂邩H */
    iy = iy_new + 2;
    if (iy >= 9)return;

	/* ̈ʒuɂj̐𐔂B */
    cnt = 0;
    if (ix_new > 0)
    {
        if (men_kifu2[ix_new - 1][iy] == 3)
        {
            cnt++;
        }
    }
    if (ix_new < 8)
    {
        if (men_kifu2[ix_new + 1][iy] == 3)
        {
            cnt++;
        }
    }

	/* ł𒲂ׂB */
    if (ix_old < 0)
    {
        if (cnt > 0)
        {
            strcat2(moji,"");
        }
        return;
    }

	/* QȏAj݂邩H */
    if (cnt < 2)return;

	/* EA */
    if (ix_old > ix_new)
    {
        strcat2(moji,"");
    }
    else
    {
        strcat2(moji,"E");
    }
}

/*****************************/
/*  ̕tL\vZB */
/*****************************/
void CShiroDlg::gin(char* moji,int ix_new,int iy_new,int ix_old,int iy_old)
{
    int ix;
    int iy;
    int i;
    int j;
    int cnt;
    int flag[3][3];

	/* tONAB */
    for (i = 0 ; i < 3 ; i++)
    {
        for ( j = 0 ; j < 3 ; j++)
        {
            flag[i][j] = 0;
        }
    }

	/* }bv쐬B */
    for (i = 0; i < 3 ; i++)
    {
        ix = ix_new + i - 1;
        if (ix < 0)continue;
        if (ix > 8)continue;
        for (j = 0 ; j < 3 ; j += 2)
        {
            iy = iy_new + j - 1;
            if (iy < 0)continue;
            if (iy > 8)continue;
            if (men_kifu2[ix][iy] == 4)flag[i][j] = 1;
        }
    }
    flag[1][0] = 0;		/* ͐^ɈȂB */

	/* ̈ʒuɍs̐𒲂ׂB */
    cnt = 0;
    for (i = 0 ; i < 3 ; i++)
    {
        for (j = 0 ; j < 3 ; j += 2)
        {
            if (flag[i][j] != 0)cnt++;
        }
    }

	/* ł𒲂ׂB */
    if (ix_old < 0)
    {
        if (cnt > 0)
        {
            strcat2(moji,"");
        }
        return;
    }

	/* Qȏ㑶݂Ȃ΁AI */
    if (cnt < 2)return;

	/* ʒȕꍇ */
    if (ix_new == ix_old)
    {
        strcat2(moji,"");
        return;
    }

	/* Aœoꍇ */
    if (iy_old < iy_new)
    {
        cnt = flag[0][0] + flag[2][0];
        if (cnt <= 1)
        {
            strcat2(moji,"");
            return;
        }
    }
    else
    {
        cnt = flag[0][2] + flag[1][2] + flag[2][2];
        if (cnt <= 1)
        {
            strcat2(moji,"");
            return;
        }
    }

	/* EA */
    if (ix_old < ix_new)
    {
        strcat2(moji,"E");
        flag[2][0] = 0;
        flag[2][2] = 0;
    }
    else
    {
        strcat2(moji,"");
        flag[0][0] = 0;
        flag[0][2] = 0;
    }

	/* oH */
    cnt = flag[0][0] + flag[0][2] + flag[2][0] + flag[2][2];
    if (cnt <= 1)return;

	/* A */
    if (iy_old < iy_new)
    {
        strcat2(moji,"");
    }
    else
    {
        strcat2(moji,"");
    }
}

/*******************************/
/*  ^̕tL\vZB */
/*******************************/
void CShiroDlg::kin(char* moji,int ix_new,int iy_new,int ix_old,int iy_old)
{
    int ix;
    int iy;
    int i;
    int j;
    int cnt;
    int koma;
    int flag[3][3];

	/* }bvtONAB */
    for (i = 0 ; i < 3 ; i++)
    {
        for ( j = 0 ; j < 3 ; j++)
        {
            flag[i][j] = 0;
        }
    }

	/* }bv쐬B */
    if (ix_old < 0)
    {
        koma = iy_old;
    }
    else
    {
        koma = men_kifu2[ix_old][iy_old];
    }
    for (i = 0; i < 3 ; i++)
    {
        ix = ix_new + i - 1;
        if (ix < 0)continue;
        if (ix > 8)continue;
        for (j = 0 ; j < 3 ; j++)
        {
            iy = iy_new + j - 1;
            if (iy < 0)continue;
            if (iy > 8)continue;
            if (men_kifu2[ix][iy] == koma)flag[i][j] = 1;
        }
    }
    flag[0][0] = 0;                     /* ͎΂߂ɈȂB */
    flag[2][0] = 0;                     /* ͎΂߂ɈȂB */

	/* ̈ʒuɂ̐𒲂ׂB */
    cnt = 0;
    for (i = 0 ; i < 3 ; i++)
    {
        for (j = 0 ; j < 3 ; j++)
        {
            if (flag[i][j] != 0)cnt++;
        }
    }

	/* ł𒲂ׂB */
    if (ix_old < 0)
    {
        if (cnt > 0)
        {
            strcat2(moji,"");
        }
        return;
    }

	/* Qȏ㑶݂Ȃ΁AI */
    if (cnt < 2)return;

	/* ʒu܂͈̏ꍇ */
    if (ix_new == ix_old)
    {
        if (iy_old < iy_new)
        {
            strcat2(moji,"");
        }
        else
        {
            strcat2(moji,"");
        }
        return;
    }

	/* œoꍇ */
    if (iy_old > iy_new)
    {
        cnt = flag[0][2] + flag[1][2] + flag[2][2];
        if (cnt <= 1)
        {
            strcat2(moji,"");
            return;
        }
    }

	/* œoꍇ */
    if (iy_old == iy_new)
    {
        cnt = flag[0][1] + flag[2][1];
        if (cnt <= 1)
        {
            strcat2(moji,"");
            return;
        }
    }

	/* EA */
    if (ix_old < ix_new)
    {
        strcat2(moji,"E");       /* ʒu}bv ix-> 2 1 0 iy */
        flag[2][1] = 0;           /*                   x o x 0  */
        flag[1][2] = 0;           /*                   o x o 1  */
        flag[2][2] = 0;           /*                   o o o 2  */ 
    }
    else
    {
        strcat2(moji,"");
        flag[0][1] = 0;
        flag[1][2] = 0;
        flag[0][2] = 0;
    }

	/* oH */
    cnt = flag[0][1] + flag[0][2] + flag[1][2] + flag[2][1] + flag[2][2];
    if (cnt <= 1)return;

	/* A */
    if (iy_old == iy_new)
    {
        strcat2(moji,"");
    }
    else
    {
        strcat2(moji,"");
    }
}

/*****************************/
/*  p̕tL\vZB */
/*****************************/
void CShiroDlg::kaku(char *moji,int ix_new,int iy_new,int ix_old,int iy_old)
{
    int ix;
    int iy;
    int i;
    int j;
    int k;
    int cnt;
    int flag[3][3];
    int ix_step;
    int iy_step;

    for (i = 0 ; i < 3 ; i += 2)
    {
        for ( j = 0 ; j < 3 ; j += 2)
        {
            flag[i][j] = 0;
        }
    }

	/* ̈ʒuɂ邩vZB */
    cnt = 0;
    for (i = 0; i < 3 ; i += 2)
    {
        ix_step = i - 1;
        for (j = 0 ; j < 3 ; j += 2)
        {
            iy_step = j - 1;
            ix      = ix_new;
            iy      = iy_new;
            for (k = 0 ; k < 8 ; k++)
            {
                ix += ix_step;
                iy += iy_step;
                if (ix < 0)break;
                if (ix > 8)break;
                if (iy < 0)break;
                if (iy > 8)break;
                if (men_kifu2[ix][iy] != 0)
                {
                    if (men_kifu2[ix][iy] == 6)
                    {
                        flag[i][j] = 1;
                        cnt++;
                    }
                    break;
                }
            }
        }
    }

	/* łꍇ̏ */
    if (ix_old < 0)
    {
        if (cnt > 0)
        {
            strcat2(moji,"");
        }
        return;
    }

	/* ̈ʒuɂP̏ꍇ */
    if (cnt <= 1)return;

	/* Aœoꍇ */
    if (iy_old < iy_new)
    {
        cnt = flag[0][0] + flag[2][0];
        if (cnt <= 1)
        {
            strcat2(moji,"");
            return;
        }
    }
    else
    {
        cnt = flag[0][2] + flag[2][2];
        if (cnt <= 1)
        {
            strcat2(moji,"s");
            return;
        }
    }

	/* EA */
    if (ix_old < ix_new)
    {
        strcat2(moji,"E");
    }
    else
    {
        strcat2(moji,"");
    }
}

/*****************************/
/*  ̕tL\vZB */
/*****************************/
void CShiroDlg::hisya(char *moji,int ix_new,int iy_new,int ix_old,int iy_old)
{
    int ix;
    int iy;
    int i;
    int j;
    int k;
    int cnt;
    int flag[3][3];
    int ix_step;
    int iy_step;

	/* }bvtONAB */
    for (i = 0 ; i < 3 ; i++)
    {
        for ( j = 0 ; j < 3 ; j++)
        {
            flag[i][j] = 0;
        }
    }

	/* ̈ʒuɂ邩vZB */
    cnt = 0;
    for (i = 0; i < 3 ; i++)
    {
        ix_step = i - 1;
        for (j = 0 ; j < 3 ; j++)
        {
            iy_step = j - 1;
            ix      = ix_new;
            iy      = iy_new;
            if (ix_step == 0)
            {
                if (iy_step == 0)continue;
            }
            else
            {
                if (iy_step != 0)continue;
            }
            for (k = 0 ; k < 8 ; k++)
            {
                ix += ix_step;
                iy += iy_step;
                if (ix < 0)break;
                if (ix > 8)break;
                if (iy < 0)break;
                if (iy > 8)break;
                if (men_kifu2[ix][iy] != 0)
                {
                    if (men_kifu2[ix][iy] == 7)
                    {
                        flag[i][j] = 1;
                        cnt++;
                    }
                    break;
                }
            }
        }
    }

	/* łꍇ̏ */
    if (ix_old < 0)
    {
        if (cnt > 0)
        {
            strcat2(moji,"");
        }
        return;
    }

	/* ̈ʒuɂP̏ꍇ */
    if (cnt <= 1)return;

	/* ̏ꍇ */
    if (iy_old < iy_new)
    {
        strcat2(moji,"");
        return;
    }

	/* ̏ꍇ */
    if (iy_old > iy_new)
    {
        strcat2(moji,"");
        return;
    }

	/* ̏ꍇ */
    if (flag[0][1] != flag[2][1])
    {
        strcat2(moji,"");
        return;
    }

	/* EȀꍇ */
    if (ix_old < ix_new)
    {
        strcat2(moji,"E");
    }
    else
    {
        strcat2(moji,"");
    }
}

/*****************************/
/*  n̕tL\vZB */
/*****************************/
void CShiroDlg::uma(char *moji,int ix_new,int iy_new,int ix_old,int iy_old)
{
    int ix;
    int iy;
    int i;
    int j;
    int k;
    int kmax;
    int cnt;
    int flag[3][3];
    int ix_step;
    int iy_step;

	/* }bvtONAB */
    for (i = 0 ; i < 3 ; i++)
    {
        for ( j = 0 ; j < 3 ; j++)
        {
            flag[i][j] = 0;
        }
    }

	/* ̈ʒuɂ邩vZB */
    cnt = 0;
    for (i = 0; i < 3 ; i++)
    {
        ix_step = i - 1;
        for (j = 0 ; j < 3 ; j++)
        {
            iy_step = j - 1;
            ix      = ix_new;
            iy      = iy_new;
            if(ix_step == 0)
            {
                if (iy_step == 0)continue;
                kmax = 1;
            }
            else if (iy_step == 0)
            {
                kmax = 1;
            }
            else
            {
                kmax = 8;
            }
            for (k = 0 ; k < kmax ; k++)
            {
                ix += ix_step;
                iy += iy_step;
                if (ix < 0)break;
                if (ix > 8)break;
                if (iy < 0)break;
                if (iy > 8)break;
                if (men_kifu2[ix][iy] != 0)
                {
                    if (men_kifu2[ix][iy] == 14)
                    {
                        flag[i][j] = 1;
                        cnt++;
                    }
                    break;
                }
            }
        }
    }

	/* ̈ʒuɂP̏ꍇ */
    if (cnt <= 1)return;

	/* AAœoꍇ */
    if (iy_old < iy_new)
    {
        cnt = flag[0][0] + flag[1][0] + flag[2][0];
        if (cnt <= 1)
        {
            strcat2(moji,"");
            return;
        }
    }
    else if (iy_old == iy_new)
    {
        cnt = flag[0][1] + flag[2][1];
        if (cnt <= 1)
        {
            strcat2(moji,"");
            return;
        }
    }
    else
    {
        cnt = flag[0][2] + flag[1][2] + flag[2][2];
        if (cnt <= 1)
        {
            strcat2(moji,"");
            return;
        }
    }

	/* EA */
    if (ix_old < ix_new)
    {
        strcat2(moji,"E");
    }
    else if (ix_old > ix_new)
    {
        strcat2(moji,"");
    }
    else if (iy_old < iy_new)
    {
        strcat2(moji,"");
    }
    else
    {
        strcat2(moji,"");              /* nnォH */
    }
}

/*****************************/
/*  ̕tL\vZB */
/*****************************/
void CShiroDlg::ryu(char *moji,int ix_new,int iy_new,int ix_old,int iy_old)
{
    int ix;
    int iy;
    int i;
    int j;
    int k;
    int kmax;
    int cnt;
    int flag[3][3];
    int ix_step;
    int iy_step;

	/* }bvtONAB */
    for (i = 0 ; i < 3 ; i++)
    {
        for ( j = 0 ; j < 3 ; j++)
        {
            flag[i][j] = 0;
        }
    }

	/* ̈ʒuɂ邩vZB */
    cnt = 0;
    for (i = 0; i < 3 ; i++)
    {
        ix_step = i - 1;
        for (j = 0 ; j < 3 ; j++)
        {
            iy_step = j - 1;
            ix      = ix_new;
            iy      = iy_new;
            if(ix_step == 0)
            {
                if (iy_step == 0)continue;
                kmax = 8;
            }
            else if (iy_step == 0)
            {
                kmax = 8;
            }
            else
            {
                kmax = 1;
            }
            for (k = 0 ; k < kmax ; k++)
            {
                ix += ix_step;
                iy += iy_step;
                if (ix < 0)break;
                if (ix > 8)break;
                if (iy < 0)break;
                if (iy > 8)break;
                if (men_kifu2[ix][iy] != 0)
                {
                    if (men_kifu2[ix][iy] == 15)
                    {
                        flag[i][j] = 1;
                        cnt++;
                    }
                    break;
                }
            }
        }
    }

	/* ̈ʒuɂP̏ꍇ */
    if (cnt <= 1)return;

	/* AAœoꍇ */
    if (iy_old < iy_new)
    {
        cnt = flag[0][0] + flag[1][0] + flag[2][0];
        if (cnt <= 1)
        {
            strcat2(moji,"");
            return;
        }
    }
    else if (iy_old == iy_new)
    {
        cnt = flag[0][1] + flag[2][1];
        if (cnt <= 1)
        {
            strcat2(moji,"");
            return;
        }
    }
    else
    {
        cnt = flag[0][2] + flag[1][2] + flag[2][2];
        if (cnt <= 1)
        {
            strcat2(moji,"");
            return;
        }
    }

	/* EA */
    if (ix_old < ix_new)
    {
        strcat2(moji,"E");
    }
    else if (ix_old > ix_new)
    {
        strcat2(moji,"");
    }
    else if (iy_old < iy_new)
    {
        strcat2(moji,"");
    }
    else
    {
        if (iy_old == (iy_new - 1))
        {
            strcat2(moji,"");          /* ォEH */
        }
        else
        {
            strcat2(moji,"");          /* ォEH */
        }
    }
}

void CShiroDlg::OnButtonJoho1() 
{
	if (prog2 == 7)
	{
		prog2 = 0;
	}
	else
	{
		prog2++;
	}
	OnInitDialog();
}

void CShiroDlg::OnButtonJoho2() 
{
	if (prog3 == 7)
	{
		prog3 = 0;
	}
	else
	{
		prog3++;
	}
	OnInitDialog();	
}

void CShiroDlg::OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar)
{
	int		ip_new;

	switch(nSBCode)
	{
	case SB_THUMBPOSITION:				// ʒuw
		ip_new = nPos;
		break;
	case SB_LINEUP:						// O
		ip_new = ip - 20;
		if (ip_new < 0)ip_new = 0;
		break;
	case SB_LINEDOWN:					// 
		ip_new = ip + 20;
		if ((ip_new + 20) > max)
		{
			ip_new = max - 20;
			if (ip_new < 0)ip_new = 0;
		}
		break;
	default:
		ip_new = ip;
		break;
	}
	if (ip != ip_new)
	{
		ip = ip_new;
		OnInitDialog();
	}

	CDialog::OnVScroll(nSBCode, nPos, pScrollBar);
}

void CShiroDlg::OnDblclkShiroList() 
{
	UpdateData(TRUE);
	EndDialog(IDOK);	
}

/**************************/
/* Rf[^ǂݍށB */
/**************************/
int CShiroDlg::shiroread(char *sman,char *gman,char *kisen,char *senkei,
						int *tesu,int *nen,int *tsuki,int *hi,int *kyoku,
						int *end_code,unsigned char kifu[][2],int *shohi,
						int *teban_flag,char *men)
{
	int		i;
	int		teai;
	int		recno;
	long	npos;
	IDX_S	idx;
	char	moji[100];
	char	filename[_MAX_PATH];
	char	senkei_moji[100][16];
	char	kisen_moji [100][20];
	FILE	*fpi;
	FILE	*fpk;

	get_kisen (kisen_moji);
	get_senkei(senkei_moji);

	strcpy_s(moji,m_list);
	recno = atoi(moji);
	if (recno <= 0)return(0);

	strcopy(filename,shiro_name);
	strcat2(filename,".MIX");
	fopen_s(&fpi,filename,"rb");
	if (fpi == NULL)return(0);

	strcopy(filename,shiro_name);
	strcat2(filename,".MKF");
	fopen_s(&fpk,filename,"rb");
	if (fpk == NULL)
	{
		fclose(fpi);
		return(0);
	}
	npos  = recno;
    npos *= 40;
    fseek(fpi,npos,SEEK_SET);
    fread(idx.sman,1,40,fpi);
	*kyoku = idx.kyoku;
	idx.kyoku = 0;
	teai   = idx.teai;
	idx.teai  = 0;
    strcopy(sman,idx.sman);
    strcopy(gman,idx.gman);
    strcopy(senkei,&senkei_moji[idx.senkei][0]);
    strcopy(kisen ,&kisen_moji[idx.kisen][0]);
    *nen   = idx.nen;
    *tsuki = idx.tsuki;
    *hi    = idx.hi;
    *end_code = idx.kachi;

    npos  = recno - 1;
    npos *= 512;
    fseek(fpk,npos,SEEK_SET);
    fread(kifu,2,256,fpk);
	shirooki(kifu);
	*tesu = ruiji(kifu,teai);
	for (i = 0; i <= 256; i++)
	{
		shohi[i] = 0;
	}
	fclose(fpi);
	fclose(fpk);

    memcpy(men,hkyokumen,100);
	switch (teai)
	{
	case 0:								// 
		*teban_flag = 0;
		break;
	case 1:								// 
		K11 = 0;
		*teban_flag = 1;
		break;
	case 2:								// p
		K22 = 0;
		*teban_flag = 1;
		break;
	case 3:								// 򗎂
		K82 = 0;
		*teban_flag = 1;
		break;
	case 4:								// 򍁗
		K82 = K11 = 0;
		*teban_flag = 1;
		break;
	case 5:								// 񖇗
		K82 = K22 = 0;
		*teban_flag = 1;
		break;
	case 6:								// l
		K11 = K91 = K22 = K82 = 0;
		*teban_flag = 1;
		break;
	case 7:								// Z
		K11 = K21 = K81 = K91 = K22 = K82 = 0;
		*teban_flag = 1;
		break;
	case 8:								// 
		K11 = K21 = K31 = K71 = K81 = K91 = K22 = K82 = 0;
		*teban_flag = 1;
		break;
	case 9:								// \
		K11 = K21 = K31 = K41 = K61 = K71 = K81 = K91 = K22 = K82 = 0;
		*teban_flag = 1;
		break;
	default:							// 
		K11 = K21 = K31 = K41 = K61 = K71 = K81 = K91 = K22 = K82 = 0;
		for (i = 19 ; i <= 27 ; i++)
		{
			men[i] = 0;
		}
		*teban_flag = 1;
		break;
	}
	return(recno);
}

void CShiroDlg::OnButtonNew() 
{
	int				len;
	int				i;
	int				recno;
	long			npos;
	DIR_S			dir;
	IDX_S			idx;
	CFileDialog	dlg(FALSE,"mix","*.mix",
							OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,
							"Rt@C(*.mix)|*.mix|SẴt@C(*.*)|*.*||",NULL);
	char			fullpath[_MAX_PATH];
	char			filename[_MAX_PATH];
	char			kifu[512];
	FILE			*fp;
	FILE			*fpii;
	FILE			*fpki;
	FILE			*fpio;
	FILE			*fpko;

	dlg.m_ofn.lpstrTitle  = "REVKt@C̐ݒ";
	if (dlg.DoModal() == IDOK)
	{
		strcpy_s(fullpath,dlg.GetPathName());
		len = strlen(fullpath) - 4;
		if ((len <= 0) || (fullpath[len] != '.'))
		{
			MessageBox("t@CɈُ킪܂B","Rt@Cݒ");
			return;
		}
		fullpath[len] = 0;

		sprintf_s(filename,"%s.MIX",shiro_name);
		fopen_s(&fpii,filename,"rb");
		sprintf_s(filename,"%s.MKF",shiro_name);
		fopen_s(&fpki,filename,"rb");

		sprintf_s(filename,"%s.MIX",fullpath);
		fopen_s(&fpio,filename,"wb");
		sprintf_s(filename,"%s.MKF",fullpath);
		fopen_s(&fpko,filename,"wb");

		sprintf_s(filename,"%s\\.DAT",Current_Dir);
		fopen_s(&fp,filename,"rb");

		memset(&dir.kensu,0,40);
		dir.kensu = max;
		fwrite(&dir.kensu,4,10,fpio);

        for (i = 1 ; i <= max ; i++)
        {
        	fread (&recno,1,4,fp);
			npos = recno;
			npos *= 40;
			fseek (fpii,npos,SEEK_SET);
			fread (idx.sman,2,20,fpii);
			fwrite(idx.sman,2,20,fpio);
			npos = recno - 1;
			npos *= 512;
			fseek (fpki,npos,SEEK_SET);
			fread (kifu,2,256,fpki);
			fwrite(kifu,2,256,fpko);
        }
        fclose(fp);
		fclose(fpii);
		fclose(fpki);
		fclose(fpio);
		fclose(fpko);
	}
}

void CShiroDlg::OnButtonSakujo() 
{

	int		delno;
	int		recno;
	int		i;
	int		max_o;
	CFile	f;
	IDX_S	idx;
	DIR_S	dir;
	char	filename[_MAX_PATH];
	char	filenamebak[_MAX_PATH];
	char	kifu[512];
	char	moji[100];
	FILE	*fpi;
	FILE	*fpo;

	if (!UpdateData(TRUE))return;
	strcpy_s(moji,m_list);
	delno = atoi(moji);
	if (delno <= 0)
	{
		MessageBox("폜f[^IĂ܂B","R");
	}
	else
	{
		sprintf_s(moji,"%dԖڂ폜Ă낵ł傤H",delno);
		if (MessageBox(moji,"R",MB_YESNO) == IDYES)
		{
			sprintf_s(filename,"%s.MIX",shiro_name);			
			fopen_s(&fpi,filename,"rb");
			sprintf_s(filenamebak,"%s.BAK",shiro_name);			
			fopen_s(&fpo,filenamebak,"wb");
			fread (&dir.kensu,4,10,fpi);
			max_o = dir.kensu;
			dir.kensu--;
			fwrite(&dir.kensu,4,10,fpo);
			for (i = 1; i <= max_o; i++)
			{
				fread (idx.sman,2,20,fpi);
				if(i == delno)continue;
				fwrite(idx.sman,2,20,fpo);
			}
			fclose(fpi);
			fclose(fpo);
			f.Remove(filename);
			f.Rename(filenamebak,filename);

			sprintf_s(filename,"%s.MKF",shiro_name);			
			fopen_s(&fpi,filename,"rb");
			sprintf_s(filenamebak,"%s.BAK",shiro_name);			
			fopen_s(&fpo,filenamebak,"wb");
			for (i = 1; i <= max_o; i++)
			{
				fread(kifu,2,256,fpi);
				if(i == delno)continue;
				fwrite(kifu,2,256,fpo);
			}
			fclose(fpi);
			fclose(fpo);
			f.Remove(filename);
			f.Rename(filenamebak,filename);

			sprintf_s(filename,"%s\\.DAT",Current_Dir);
			fopen_s(&fpi,filename,"rb");
			if (fpi == NULL)return;
			sprintf_s(filenamebak,"%s\\.BAK",Current_Dir);
			fopen_s(&fpo,filenamebak,"wb");
			if (fpo == NULL)
			{
				fclose(fpi);
				return;
			}
			max_o = 0;
			for (i = 0; i < max; i++)
			{
				fread(&recno,1,4,fpi);
				if(recno == delno)continue;
				if (recno > delno)
				{
					recno--;
				}
				fwrite(&recno,1,4,fpo);
				max_o++;
			}
			fclose(fpi);
			fclose(fpo);
			f.Remove(filename);
			f.Rename(filenamebak,filename);
			max = max_o;
			if ((ip + 20) > max)ip = max - 20;
			if (ip < 0)ip = 0;
			if (max <= 0)
			{
				EndDialog(IDCANCEL);
			}
			else
			{
				OnInitDialog();
			}
		}
	}
}

/************************************/
/* R̊t@CɃZ[uB */
/************************************/

BOOL CShiroDlg::shiro_save(int *recno,unsigned char kifu[][2],char *sman,char *gman,
						char *kisen,char *senkei,int teban_flag,int kyoku,
						int nen,int tsuki,int hi,int end_code,char *men,
						char *mess,char *shiro_name)
{
	int				i;
	int				teai;
    int          	tesu;
    long         	npos;
	IDX_S			idx;
	DIR_S			dir;
    char         	idx_name[_MAX_PATH];
    char         	kif_name[_MAX_PATH];
    unsigned char	kifu2[257][2];
    FILE         	*fpi;
    FILE         	*fpk;

    /**************/
    /* ǖʐ} */
    /**************/
	teai = teai_no(men,teban_flag);
	if (teai < 0)
	{
        strcopy(mess,"Z[uΏۂ̊ł͂܂B");
        return(TRUE);
    }

    /******************/
    /* t@C쐬 */
    /******************/
	sprintf_s(idx_name,"%s.MIX",shiro_name);
	sprintf_s(kif_name,"%s.MKF",shiro_name);

    /******************************/
    /* t@Cǂݍ݁@@g */
    /******************************/
    if (*recno == 0)
    {
        memset(idx.sman,0,40);
        fopen_s(&fpi,idx_name,"ab");
        fwrite(idx.sman,2,20,fpi);
        fclose(fpi);

        fopen_s(&fpi,idx_name,"r+b");
        fread(&dir.kensu,4,10,fpi);
        dir.kensu++;
        npos = 0;
        fseek(fpi,npos,SEEK_SET);
        fwrite(&dir.kensu,4,10,fpi);
        *recno = dir.kensu;

        fopen_s(&fpk,kif_name,"ab");
        fwrite(kifu2,2,256,fpk);
        fclose(fpk);
    }
    else
    {
        fopen_s(&fpi,idx_name,"r+b");
        npos  = *recno;
        npos *= 40;
        fseek(fpi,npos,SEEK_SET);
        fread(idx.sman,2,20,fpi);
    }
    fopen_s(&fpk,kif_name,"r+b");

    /****************/
    /* obt@ҏW */
    /****************/
    memset(kifu2,0,514);
	for (i = teban_flag; i <= 256 ; i++)
	{
		if (kifu[i][0] == 0)break;
        kifu2[i][0] = kifu[i][0];
		kifu2[i][1] = kifu[i][1];
	}
    tesu = okishiro(kifu2,teai);

    get_moji(idx.sman,sman,12);
    get_moji(idx.gman,gman,12);
    idx.kisen  = get_data_no(kisen,100,".DAT",3);
    idx.kyoku  = kyoku;
    idx.nen    = nen;
    idx.tsuki  = tsuki;
    idx.hi     = hi;
    idx.senkei = get_data_no(senkei,100,"^.DAT",4);
    idx.kachi  = end_code;
	if (tesu == 256)
	{
		if (kifu[256][0] != 0)
		{
			if ((idx.kachi >= 1) && (idx.kachi <= 4))
			{
				idx.kachi += 4;
			}
		}
	} 
	idx.teai   = teai;

    /********************/
    /* t@C */
    /********************/
    npos  = *recno;
    npos *= 40;
    fseek(fpi,npos,SEEK_SET);
    fwrite(idx.sman,2,20,fpi);
    fclose(fpi);

    npos  = *recno - 1;
    npos *= 512;
    fseek(fpk,npos,SEEK_SET);
    fwrite(kifu2,2,256,fpk);
    fclose(fpk);
	return(FALSE);
}

/******************************/
/* 荇ǖʐ}狁߂B */
/******************************/
int	CShiroDlg::teai_no(char *imen,int teban_flag)
{
	int		i;
	char	men[100];

    if (teban_flag == 0)
    {
        if (memcmp(imen,hkyokumen,100) == 0)return(0);
    }
    else
    {
		memcpy(men,hkyokumen,100);
		K11 = 0;
        if (memcmp(imen,men,100) == 0)return(1);
		K11 = GKYO;
		K22 = 0;
        if (memcmp(imen,men,100) == 0)return(2);
		K82 = 0;
		K22 = GKAKU;
        if (memcmp(imen,men,100) == 0)return(3);
		K11 = 0;
        if (memcmp(imen,men,100) == 0)return(4);
		K11 = GKYO;
		K22 = 0;
        if (memcmp(imen,men,100) == 0)return(5);
		K11 = K91 = 0;
        if (memcmp(imen,men,100) == 0)return(6);
		K21 = K81 = 0;
        if (memcmp(imen,men,100) == 0)return(7);
		K31 = K71 = 0;
        if (memcmp(imen,men,100) == 0)return(8);
		K41 = K61 = 0;
        if (memcmp(imen,men,100) == 0)return(9);
		for (i = 19 ; i <= 27 ; i++)
		{
			men[i] = 0;
		}
		if (memcmp(imen,men,100) == 0)return(10);
	}
	return(-1);
}

/*********************************************************************/
/*                                                                   */
/*           Bf[^\\\Rf[^ϊ    @uPDOO    */
/*                                                                   */
/*           @\@@F@Bf[^Rf[^ɕϊB          */
/*                                                                   */
/*                       BR                                  */
/*                                                                   */
/*           쐬ҁ@F@{q(SAF53393 & GCA02313 & TORA0332)    */
/*                                                                   */
/*           쐬@F@OVNPQQT                      */
/*                                                                   */
/*-------------------------------------------------------------------*/
/*                                                                   */
/*           ύXPF@@@N@@@@                      */
/*                                                                   */
/*           ύX_PF@@@@@@@@@@@@@@@                */
/*                                                                   */
/*********************************************************************/

int CShiroDlg::okishiro(unsigned char kifu[][2],int teai)
{
    int         tesu;

    /*  */
    kifu[256][0] = 0;
	if (teai == 0)
	{
		tesu = 0;
	}
	else
	{
		tesu = 1;
		kifu[0][0] = 255;
		kifu[0][1] = teai;
	}

    /* ۂɊȂׂĂ݂B */
    while(kifu[tesu][0])
    {
		if (kifu[tesu][0] > 81)kifu[tesu][0] += 28;
		if (kifu[tesu][1] > 81)kifu[tesu][1] += 28;
        tesu++;
    }
    return(tesu);
}

int CShiroDlg::get_data_no(char *man,int max,char *file_name,int ip)
{
    int     no;
    char    data[28];
    char    moji[80];
	char	filename[_MAX_PATH];
    FILE    *fp;

    all_space_cut(data,man);
    if (data[0] == 0)return(0);

	sprintf_s(filename,"%s\\%s",Current_Dir,file_name);
    fopen_s(&fp,filename,"r");
    if (fp == NULL)return(0);
    while(fgets(moji,sizeof(moji),fp))
    {
        no = atoi(moji);
        if (no <= 0)continue;
        if (no > max)continue;
        all_space_cut(moji,&moji[ip]);
        if (strcmp(data,moji) == 0)
        {
            fclose(fp);
            return(no);
        }
    }
    fclose(fp);
    return(0);
}

/* ׂẴXy[XJbgB */
void CShiroDlg::all_space_cut(char *s2,char *s1)
{
    while(*s1)
    {
        if(*s1 == ' ')
        {
            s1++;
        }
        else if (*s1 == '\n')
        {
            *s2 = 0;
            break;
        }
        else if (strncmp(s1,"@",2) == 0)
        {
            s1 += 2;
        }
        else if (moji_size(*s1) == 2)
        {
            *s2++ = *s1++;
            *s2++ = *s1++;
        }
        else
        {
            *s2++ = *s1++;
        }
    }
    *s2 = 0;
}

