/************************/
/*       sikou.cpp      */
/************************/
#include "stdafx.h"
#include "sente.h"

extern void	strcopy(char *s1,char *s2);
extern void kifuout2(int tesv,char *cmoji,char *hmen,int moto,int saki,int naru);
extern void sasu(char *men,int teban,int moto,int saki,int naru);

extern int				timer_max;
extern int				teban_flag;
extern int				chudan_flag;
extern int				ura_stop;
extern int				tesu;
extern int				teban7;
extern int				end_code;
extern int				oki_run_flag;
extern int				i_man[];
extern int				i_senpo[];
extern int				shohi[];
extern int				timer_sec[];
extern char				men_h[];
extern unsigned char	kifu[][2];
extern char				teban_moji1[];
extern char				teban_moji2[];
extern char				initial_kyokumen[];
extern CString			sikou_joseki;

/******************/
/* lDLL ` */
/******************/

typedef void(*TUMI_INI)();
typedef int (*TUMI_TUMI)(char *men,int teban,int tesu,int *m_moto,int *m_saki,int *m_naru);
typedef BOOL(*TUMI_UKE)(int tume_kind,int tumi_tesu,char* men2,int tesu,
						int *m_moto,int *m_saki,int *m_naru,int *iend);
typedef void (*TUMI_SEME)(int tume_kind,int *tumi_tesu,char *men2,int tesu,
											int *m_moto,int *m_saki,int *m_naru);
typedef void(*TUMI_KILL)();
typedef	int (*TUMI_OVER)();
typedef void(*TUMI_END)();

typedef void(*OKI_TACHIAGE)(HINSTANCE lib,int *cflag,CString jfile);
typedef void(*OKI_INI)(char *imen,int teban_flag,CString jfile,int *isenpo);
typedef int(*OKI_SIKOU)(int tesu,unsigned char kifu[][2],int *timer_sec,int *i_moto,int *i_saki,int *i_naru,int level);
typedef void(*OKI_URA)(char *men,int tesu,unsigned char kifu[][2],int *ura_stop);
typedef void(*OKI_END)();

static TUMI_INI		tumi_ini;
static TUMI_TUMI	tumi_1;
static TUMI_TUMI	tumi_2;
static TUMI_TUMI	tumi_3;
static TUMI_UKE		uke_x;
static TUMI_SEME	seme_x;
static TUMI_KILL	tumi_kill3;
static TUMI_OVER	h_over;
static TUMI_END		tumi_end;
static OKI_INI		oki_ini;
static OKI_SIKOU	oki_sikou;
static OKI_URA		oki_ura;
static OKI_END      oki_end;

static HANDLE			hEvent;
static int				stop_flag;
static int				tumi_kind;
static char				tumi_men[100];
static int				tumi_teban;
char					tumi_message[80];
static unsigned char	kifu2[3002][2];

/******************/
/* _~[[` */
/******************/

static void dummy_ini()
{
}

static void	dummy_kill()
{
}

static int  dummy_tumi(char *men,int teban,int tesu,int *m_moto,int *m_saki,int *m_naru)
{
	return(0);
}

static BOOL dummy_uke(int tume_kind,int tumi_tesu,char* men2,int tesu,
						int *m_moto,int *m_saki,int *m_naru,int *iend)
{
	*m_moto = *m_saki = *m_naru = 0;
	return(FALSE);
}

static void dummy_seme(int tume_kind,int *tumi_tesu,char *men2,int tesu,
									int *m_moto,int *m_saki,int *m_naru)
{
}

static void dummy_end()
{
}

static int dummy_over()
{
	return(1);
}

static void dummy_ini2(char *imen,int teban_flag,CString jfile,int *i_senpo)
{
}

static int dummy_sikou2(int tesu,unsigned char kifu[][2],int *timer_sec,int *i_moto,int *i_saki,int *i_naru,int level)
{
	return(0);
}

static void dummy_ura(char *men,int tesu,unsigned char kifu[][2],int *ura_stop)
{
}

static int tumi_hansoku(char *men,int teban,char *mess)
{
	int		i;
	int		kotae;
	int		j;
	char	ou;

	strcopy(mess,"zuɖ肪A̋l͉܂B");

	/* `FbNsB */
    if (men[99 - teban] == 0)
    {
    	strcopy(mess,"Gʂ܂B");
		return(1);
	}

	strcopy(mess,"zuɈُ킪܂B");
    for (i = 1 ; i <= 9 ; i++)
    {
        switch (men[i])
        {
        case SFU:
        case SKYO:
        case SKEI:
            return(2);
        default:
            break;
        }
    }

    for (i = 10 ; i <= 18 ; i++)
    {
        if (men[i] == SKEI)return(3);
    }

    for (i = 64 ; i <= 72 ; i++)
    {
        if (men[i] == GKEI)return(4);
    }

    for (i = 73 ; i <= 81 ; i++)
    {
        switch (men[i])
        {
        case GFU:
        case GKYO:
        case GKEI:
            return(5);
        default:
            break;
        }
    }

    for (i = 1 ; i <= 9 ; i++)
    {
        kotae = 0;
        for (j = i + 9 ; j <= 81 ; j += 9)
        {
            if (men[j] == SFU)kotae++;
        }
        if (kotae >= 2)return(6);
    }

    for (i = 1 ; i <= 9 ; i++)
    {
        kotae = 0;
        for (j = i ; j <= 72 ; j += 9)
        {
            if (men[j] == GFU)kotae++;
        }
        if (kotae >= 2)return(7);
    }
    if (teban)
    {
        ou = 8;
    }
    else
    {
        ou = -8;
    }
    for (i = 1 ; i <= 81 ; i++)
    {
        if (men[i] == ou)
        {
            if (i != men[99 - teban])return(8);
        }
    }
	return(0);
}

static UINT TumiThreadProc(LPVOID pParam)
{
	int		tumi_tesu;
	int		kotae;
	int		tesu_x;
	int		m_moto[3000];
	int		m_saki[3000];
	int		m_naru[3000];
	char	men2[100];

	if (tumi_hansoku(tumi_men,tumi_teban,tumi_message))
	{
		::PostMessage((HWND)pParam,WM_TUMI,1,0);
	}
	else
	{
		switch(tumi_kind)
		{
		case 0:
		case 4:
			teban_moji2[0] = 0;
			for (tumi_tesu = 1; tumi_tesu < 50 ; tumi_tesu += 2)
			{
				sprintf_s(teban_moji1,28,"%dl͒",tumi_tesu);
				::PostMessage((HWND)pParam,WM_TUMI,0,2);
				kotae = tumi_2(tumi_men,tumi_teban,tumi_tesu,m_moto,m_saki,m_naru);
				if (chudan_flag)
				{
					strcopy(teban_moji1,"@ ͒~B");
					::PostMessage((HWND)pParam,WM_TUMI,4,0);
					break;
				}
				if (kotae > 0)
				{
					kifuout2(tumi_teban,teban_moji1,tumi_men,m_moto[0],m_saki[0],m_naru[0]);
					sprintf_s(teban_moji2,28,"%dŋl݂܂B",tumi_tesu);
					::PostMessage((HWND)pParam,WM_TUMI,2,0);
					break;
				}
				else if (kotae == 0)
				{
					strcopy(teban_moji1,"@l݂܂B");
					tumi_message[0] = 0;
					::PostMessage((HWND)pParam,WM_TUMI,2,0);
					break;
				}
				else if (tumi_tesu > 5)
				{
					if (h_over())
					{
				   		sprintf_s(teban_moji1,28,"%dl܂ŉ́B",tumi_tesu);
    					strcopy(teban_moji2,"͒fO܂B");
						::PostMessage((HWND)pParam,WM_TUMI,2,0);
						break;
					}
				}
			}
			if (tumi_tesu > 50)
			{
		   		strcopy(teban_moji1,"49l܂ŉ́B");
				strcopy(teban_moji2,"͒fO܂B");
				::PostMessage((HWND)pParam,WM_TUMI,2,0);
			}
			break;
		case 1:
			teban_moji2[0] = 0;
			for (tumi_tesu = 1; tumi_tesu < 50 ; tumi_tesu += 2)
			{
				sprintf_s(teban_moji1,28,"%dl͒",tumi_tesu);
				::PostMessage((HWND)pParam,WM_TUMI,0,1);
				kotae = tumi_1(tumi_men,tumi_teban,tumi_tesu,m_moto,m_saki,m_naru);
				if (chudan_flag)
				{
					::PostMessage((HWND)pParam,WM_TUMI,4,1);
					break;
				}
				if (kotae > 0)
				{
					memcpy(men2,tumi_men,100);
					strcopy(teban_moji1,"l݂܂(^_^)");
					end_code = 0;
					tesu_x = tesu;
					kifu[tesu_x + 1][0] = 0;
					kifu[tesu_x][1] = m_moto[0];
					kifu[tesu_x][0] = m_saki[0] + m_naru[0] * NARU_CODE;
					shohi[tesu_x]   = timer_sec[tumi_teban];
					teban7          = 1 - teban7;
					::PostMessage((HWND)pParam,WM_TUMI,3,1);
					while(1)
					{
						tumi_tesu -= 2;
						if (tumi_tesu < 0)
						{
							if (tumi_teban)
							{
								end_code = 2;
							}
							else
							{
								end_code = 1;
							}
							::PostMessage((HWND)pParam,WM_TUMI,4,1);
							break;
						}
						if (uke_x(tumi_kind,tumi_tesu,men2,tesu_x,m_moto,m_saki,m_naru,&end_code))
						{
							tesu_x++;
							kifu[tesu_x + 1][0] = 0;
							kifu[tesu_x][1] = m_moto[0];
							kifu[tesu_x][0] = m_saki[0] + m_naru[0] * 100;
							shohi[tesu_x]   = timer_sec[teban7];
							teban7          = 1 - teban7;
							::PostMessage((HWND)pParam,WM_TUMI,0,1);
						}
						else
						{
							break;
						}

						seme_x(tumi_kind,&tumi_tesu,men2,tesu_x,m_moto,m_saki,m_naru);
						tesu_x++;
						kifu[tesu_x + 1][0] = 0;
						kifu[tesu_x][1] = m_moto[0];
						kifu[tesu_x][0] = m_saki[0] + m_naru[0] * 100;
						shohi[tesu_x]   = timer_sec[teban7];
						teban7          = 1 - teban7;
						::PostMessage((HWND)pParam,WM_TUMI,0,1);
					}
					break;
				}
				else if (kotae == 0)
				{
					strcopy(teban_moji1,"@l݂܂B");
					tumi_message[0] = 0;
					::PostMessage((HWND)pParam,WM_TUMI,2,1);
					break;
				}
			}
			if (tumi_tesu > 50)
			{
		   		strcopy(teban_moji1,"49l܂ŉ́B");
				strcopy(teban_moji2,"͒fO܂B");
				::PostMessage((HWND)pParam,WM_TUMI,2,0);
			}
			break;
		case 2:
			teban_moji2[0] = 0;
			for (tumi_tesu = 1; tumi_tesu < 50 ; tumi_tesu += 2)
			{
				sprintf_s(teban_moji1,28,"%dl͒",tumi_tesu);
				::PostMessage((HWND)pParam,WM_TUMI,0,2);
				kotae = tumi_2(tumi_men,tumi_teban,tumi_tesu,m_moto,m_saki,m_naru);
				if (chudan_flag)
				{
					::PostMessage((HWND)pParam,WM_TUMI,4,2);
					break;
				}
				if (kotae > 0)
				{
					memcpy(men2,tumi_men,100);
					strcopy(teban_moji1,"l݂܂(^_^)");
					end_code = 0;
					tesu_x = tesu;
					kifu[tesu_x + 1][0] = 0;
					kifu[tesu_x][1] = m_moto[0];
					kifu[tesu_x][0] = m_saki[0] + m_naru[0] * NARU_CODE;
					shohi[tesu_x]   = timer_sec[tumi_teban];
					teban7          = 1 - teban7;
					::PostMessage((HWND)pParam,WM_TUMI,3,2);
					while(1)
					{
						tumi_tesu -= 2;
						if (tumi_tesu < 0)
						{
							if (tumi_teban)
							{
								end_code = 2;
							}
							else
							{
								end_code = 1;
							}
							::PostMessage((HWND)pParam,WM_TUMI,4,2);
							break;
						}
						if (uke_x(tumi_kind,tumi_tesu,men2,tesu_x,m_moto,m_saki,m_naru,&end_code))
						{
							tesu_x++;
							kifu[tesu_x + 1][0] = 0;
							kifu[tesu_x][1] = m_moto[0];
							kifu[tesu_x][0] = m_saki[0] + m_naru[0] * 100;
							shohi[tesu_x]   = timer_sec[teban7];
							teban7          = 1 - teban7;
							::PostMessage((HWND)pParam,WM_TUMI,0,2);
						}
						else
						{
							break;
						}

						seme_x(tumi_kind,&tumi_tesu,men2,tesu_x,m_moto,m_saki,m_naru);
						tesu_x++;
						kifu[tesu_x + 1][0] = 0;
						kifu[tesu_x][1] = m_moto[0];
						kifu[tesu_x][0] = m_saki[0] + m_naru[0] * 100;
						shohi[tesu_x]   = timer_sec[teban7];
						teban7          = 1 - teban7;
						::PostMessage((HWND)pParam,WM_TUMI,0,2);
					}
					break;
				}
				else if (kotae == 0)
				{
					strcopy(teban_moji1,"@l݂܂B");
					tumi_message[0] = 0;
					::PostMessage((HWND)pParam,WM_TUMI,2,2);
					break;
				}
			}
			if (tumi_tesu > 50)
			{
		   		strcopy(teban_moji1,"49l܂ŉ́B");
				strcopy(teban_moji2,"͒fO܂B");
				::PostMessage((HWND)pParam,WM_TUMI,2,0);
			}
			break;
		case 3:
			teban_moji1[0] = teban_moji2[0] = 0;
			kotae = tumi_3(tumi_men,tumi_teban,49,m_moto,m_saki,m_naru);	
			sprintf_s(tumi_message,"%d (%d,%d,%d)",kotae,m_moto[0],m_saki[0],m_naru[0]);
			::PostMessage((HWND)pParam,WM_TUMI,1,3);
			break;
		case 5:		// l@
			teban_moji2[0] = 0;
			sprintf_s(teban_moji1,28,"@@͒");
			::PostMessage((HWND)pParam,WM_TUMI,0,5);
			kotae = tumi_3(tumi_men,0,49,m_moto,m_saki,m_naru);	

			if (kotae > 0)
			{
				kifuout2(0,teban_moji1,tumi_men,m_moto[0],m_saki[0],m_naru[0]);
				sprintf_s(teban_moji2,28,"%dŋl݂܂B",kotae);
				::PostMessage((HWND)pParam,WM_TUMI,2,3);
			}
			else if (kotae == 0)
			{
				strcopy(teban_moji1,"@l݂܂B");
			}
			else
			{
		   		strcopy(teban_moji1,"@܂B");
				strcopy(teban_moji2,"͒fO܂B");
			}
			::PostMessage((HWND)pParam,WM_TUMI,2,5);
			break;
		case 6:		// l@
			teban_moji2[0] = 0;
			sprintf_s(teban_moji1,28,"@@͒");
			::PostMessage((HWND)pParam,WM_TUMI,0,6);
			kotae = tumi_3(tumi_men,1,49,m_moto,m_saki,m_naru);	
			if (kotae > 0)
			{
				kifuout2(1,teban_moji1,tumi_men,m_moto[0],m_saki[0],m_naru[0]);
				sprintf_s(teban_moji2,28,"%dŋl݂܂B",kotae);
				::PostMessage((HWND)pParam,WM_TUMI,2,3);
			}
			else if (kotae == 0)
			{
				strcopy(teban_moji1,"@l݂܂B");
			}
			else
			{
		   		strcopy(teban_moji1,"@܂B");
				strcopy(teban_moji2,"͒fO܂B");
			}
			::PostMessage((HWND)pParam,WM_TUMI,2,6);
			break;
		default:
			break;
		}
	}
	return(0);
}

void tumi_kick(int kind,HWND m_hWnd)
{
	tumi_kind  = kind;
	memcpy(tumi_men,men_h,100);
	switch(tumi_kind)
	{
	case 0:
		tumi_teban = 0;
		break;
	case 4:
		tumi_teban = 1;
		break;
	default:
		tumi_teban = tesu & 0x0001;
		break;
	}
	AfxBeginThread(TumiThreadProc,m_hWnd,THREAD_PRIORITY_NORMAL);
}

/***************************/
/* lDLLƃNB */
/***************************/

HINSTANCE set_tumi_dll(CString m_dll,CString m_ini,CString m_sikou,CString m_end)
{
	HINSTANCE	lib;
	TUMI_INI	ini_proc;
	TUMI_TUMI	tumi_proc;
	TUMI_KILL	kill_proc;
	TUMI_END	end_proc;
	char		filename[_MAX_PATH];

	strcpy_s(filename,m_dll);
	if (filename[0])
	{
		lib = LoadLibrary(filename);
		if (lib)
		{
			ini_proc = (TUMI_INI)GetProcAddress(lib,m_ini);
			if (ini_proc)
			{
				tumi_ini = ini_proc;
			}
			else
			{
				tumi_ini = dummy_ini;
			}

			tumi_proc = (TUMI_TUMI)GetProcAddress(lib,m_sikou);
			if (tumi_proc)
			{
				tumi_3 = tumi_proc;
			}
			else
			{
				tumi_3 = dummy_tumi;
			}

			kill_proc = (TUMI_KILL)GetProcAddress(lib,_T("kill_process"));
			if (kill_proc)
			{
				tumi_kill3 = kill_proc;
			}
			else
			{
				tumi_kill3 = dummy_kill;
			}

			end_proc = (TUMI_END)GetProcAddress(lib,m_end);
			if (end_proc)
			{
				tumi_end = end_proc;
			}
			else
			{
				tumi_end = dummy_end;
			}
		}
		else
		{
			tumi_ini   = dummy_ini;
			tumi_3     = dummy_tumi;
			tumi_kill3 = dummy_kill;
			tumi_end   = dummy_end;
		}
	}
	else
	{
		tumi_ini   = dummy_ini;
		tumi_3     = dummy_tumi;
		tumi_kill3 = dummy_kill;
		tumi_end   = dummy_end;
	}
	tumi_ini();
	return(lib);
}

/***************************/
/* vlDLLƃNB */
/***************************/

void set_sikou_dll(CString m_dll,HINSTANCE libt,CString m_joseki,CString m_tachiage,
				   CString m_ini,CString m_sikou,CString m_ura,CString m_end)
{
	HINSTANCE		lib;
	TUMI_TUMI		tumi_proc;
	TUMI_UKE		uke_proc;
	TUMI_SEME		seme_proc;
	TUMI_OVER		over_proc;
	OKI_TACHIAGE	tachiage_proc;
	OKI_INI			ini_proc;
	OKI_SIKOU		sikou_proc;
	OKI_URA			ura_proc;
	OKI_END			end_proc;
	char			filename[_MAX_PATH];

	strcpy_s(filename,m_dll);
	if (filename[0])
	{
		lib = LoadLibrary(filename);
		if (lib)
		{
			tumi_proc = (TUMI_TUMI)GetProcAddress(lib,_T("tumi_m"));
			if (tumi_proc)
			{
				tumi_1 = tumi_proc;
			}
			else
			{
				tumi_1 = dummy_tumi;
			}

			tumi_proc = (TUMI_TUMI)GetProcAddress(lib,_T("tumi_f"));
			if (tumi_proc)
			{
				tumi_2 = tumi_proc;
			}
			else
			{
				tumi_2 = dummy_tumi;
			}

			uke_proc = (TUMI_UKE)GetProcAddress(lib,_T("uke_x"));
			if (uke_proc)
			{
				uke_x = uke_proc;
			}
			else
			{
				uke_x = dummy_uke;
			}

			seme_proc = (TUMI_SEME)GetProcAddress(lib,_T("seme_x"));
			if (seme_proc)
			{
				seme_x = seme_proc;
			}
			else
			{
				seme_x = dummy_seme;
			}

			over_proc = (TUMI_OVER)GetProcAddress(lib,_T("h_over"));
			if (over_proc)
			{
				h_over = over_proc;
			}
			else
			{
				h_over = dummy_over;
			}

			tachiage_proc = (OKI_TACHIAGE)GetProcAddress(lib,m_tachiage);
			if (tachiage_proc)
			{
				tachiage_proc(libt,&chudan_flag,m_joseki);
			}

			ini_proc = (OKI_INI)GetProcAddress(lib,m_ini);
			if (ini_proc)
			{
				oki_ini = ini_proc;
			}
			else
			{
				oki_ini = dummy_ini2;
			}

			sikou_proc = (OKI_SIKOU)GetProcAddress(lib,m_sikou);
			if (sikou_proc)
			{
				oki_sikou = sikou_proc;
			}
			else
			{
				oki_sikou = dummy_sikou2;
			}

			ura_proc = (OKI_URA)GetProcAddress(lib,m_ura);
			if (ura_proc)
			{
				oki_ura = ura_proc;
			}
			else
			{
				oki_ura = dummy_ura;
			}

			end_proc = (OKI_END)GetProcAddress(lib,m_end);
			if (end_proc)
			{
				oki_end = end_proc;
			}
			else
			{
				oki_end = dummy_end;
			}
		}
		else
		{
			tumi_1         = dummy_tumi;
			tumi_2         = dummy_tumi;
			uke_x	       = dummy_uke;
			seme_x	       = dummy_seme;
			h_over         = dummy_over;
			oki_ini        = dummy_ini2;
			oki_sikou      = dummy_sikou2;
			oki_ura        = dummy_ura;
			oki_end        = dummy_end;
		}
	}
	else
	{
		tumi_1         = dummy_tumi;
		tumi_2         = dummy_tumi;
		uke_x	       = dummy_uke;
		seme_x	       = dummy_seme;
		h_over         = dummy_over;
		oki_ini        = dummy_ini2;
		oki_sikou      = dummy_sikou2;
		oki_ura        = dummy_ura;
		oki_end        = dummy_end;
	}
}

/*******************/
/* DLLB */
/*******************/

void free_tumi_dll()
{
	tumi_end();
}

/********************/
/* Bvl[` */
/********************/

static UINT OkiThreadProc(LPVOID pParam)
{
	int		moto;
	int		saki;
	int		naru;
	int		teban;
	int		kotae;
	int		level;
	int		nokori;

	oki_run_flag = 1;
	stop_flag = 0;
	oki_ini(initial_kyokumen,teban_flag,sikou_joseki,i_senpo);

	while(1)
	{
		WaitForSingleObject(hEvent,INFINITE);
		if (stop_flag)break;
		if (chudan_flag)break;
		teban = tesu & 0x0001;
		level = i_man[teban];
		if (timer_max)
		{
			nokori = timer_max - timer_sec[teban];
		}
		else
		{
			nokori = 12345;
		}

		if (nokori <= 1)
		{
			kotae = 0;
		}
		else
		{
			if (nokori < 30)
			{
				level = 1;
			}
			else if (nokori < 60)
			{
				if (level > 2)level = 2;
			}
			else if (nokori < 90)
			{
				if (level > 3)level = 3;
			}
			else if (nokori < 120)
			{
				if (level > 4)level = 4;
			}
			else if (nokori < 150)
			{
				if (level > 5)level = 5;
			}
			else if (nokori < 180)
			{
				if (level > 6)level = 6;
			}
			else if (nokori < 210)
			{
				if (level > 7)level = 7;
			}
			else if (nokori < 300)
			{
				level = 8;
			}
			kotae = oki_sikou(tesu,kifu,timer_sec,&moto,&saki,&naru,level);
		}
		switch(kotae)
		{
		case 0:		// 
			::PostMessage((HWND)pParam,WM_SASITE,0,-1);
			break;
		case -1:	// (Not define)
		case -2:	// ҂(Not define)
		case -3:	// f(Not define)
			::PostMessage((HWND)pParam,WM_SASITE,0,kotae);
			break;
		default:
			if (naru)
			{
				saki += NARU_CODE;
			}
			::PostMessage((HWND)pParam,WM_SASITE,moto,saki);
			break;
		}
	}
	oki_end();
	CloseHandle(hEvent);
	oki_run_flag = 0;
	return(0);
}

/*******************************/
/* Bvl[` ǂݕt */
/*******************************/

static UINT UraOkiThreadProc(LPVOID pParam)
{
	int		moto;
	int		saki;
	int		naru;
	int		teban;
	int		kotae;
	int		tesu_h;
	int		level;
	int		nokori;
	char	men[100];

	oki_run_flag = 1;
	stop_flag    = 0;
	oki_ini(initial_kyokumen,teban_flag,sikou_joseki,i_senpo);

	teban = tesu & 0x0001;
	level = i_man[teban];
	if (level > 0)
	{
		if (timer_max)
		{
			nokori = timer_max - timer_sec[teban];
		}
		else
		{
			nokori = 12345;
		}
		if (nokori <= 1)
		{
			kotae = 0;
		}
		else
		{
			if (nokori < 30)
			{
				level = 1;
			}
			else if (nokori < 60)
			{
				if (level > 2)level = 2;
			}
			else if (nokori < 90)
			{
				if (level > 3)level = 3;
			}
			else if (nokori < 120)
			{
				if (level > 4)level = 4;
			}
			else if (nokori < 150)
			{
				if (level > 5)level = 5;
			}
			else if (nokori < 180)
			{
				if (level > 6)level = 6;
			}
			else if (nokori < 210)
			{
				if (level > 7)level = 7;
			}
			else if (nokori < 300)
			{
				if (level > 8)level = 8;
			}
			kotae  = oki_sikou(tesu,kifu,timer_sec,&moto,&saki,&naru,level);

		}
		WaitForSingleObject(hEvent,INFINITE);
		if (ura_stop > 0)ura_stop = 0;
		if (stop_flag)
		{
			oki_end();
			CloseHandle(hEvent);
			oki_run_flag = 0;
			return(1);
		}
		else if (chudan_flag)
		{
			oki_end();
			CloseHandle(hEvent);
			oki_run_flag = 0;
			return(2);
		}
		switch(kotae)
		{
		case 0:		// 
			::PostMessage((HWND)pParam,WM_SASITE,0,-1);
			break;
		case -1:	// (Not define)
		case -2:	// ҂(Not define)
		case -3:	// f(Not define)
			::PostMessage((HWND)pParam,WM_SASITE,0,kotae);
			break;
		default:
			tesu_h = tesu;
			memcpy(men,men_h,100);
			if (naru)
			{
				::PostMessage((HWND)pParam,WM_SASITE,moto,saki + NARU_CODE);
			}
			else
			{
				::PostMessage((HWND)pParam,WM_SASITE,moto,saki);
			}
			break;
		}
		if (kotae > 0)
		{
			sasu(men,teban,moto,saki,naru);
			kifu2[tesu_h][1] = moto;
			if (naru)
			{
				kifu2[tesu_h][0] = saki + NARU_CODE;
			}
			kifu2[tesu_h][0] = saki;
			tesu_h++;
			kifu2[tesu_h][0] = 0;
			oki_ura(men,tesu_h,kifu2,&ura_stop);
		}
	}
	else
	{
		tesu_h = tesu;
		memcpy(men,men_h,100);
		oki_ura(men,tesu_h,kifu2,&ura_stop);
	}

	while(1)
	{
		WaitForSingleObject(hEvent,INFINITE);
		if (ura_stop > 0)ura_stop = 0;
		if (stop_flag)break;
		if (chudan_flag)break;
		teban  = tesu & 0x0001;

		level  = i_man[teban];
		if (timer_max)
		{
			nokori = timer_max - timer_sec[teban];
		}
		else
		{
			nokori = 12345;
		}

		if (nokori <= 1)
		{
			kotae = 0;
		}
		else
		{
			if (nokori < 30)
			{
				level = 1;
			}
			else if (nokori < 60)
			{
				if (level > 2)level = 2;
			}
			else if (nokori < 90)
			{
				if (level > 3)level = 3;
			}
			else if (nokori < 120)
			{
				if (level > 4)level = 4;
			}
			else if (nokori < 150)
			{
				if (level > 5)level = 5;
			}
			else if (nokori < 180)
			{
				if (level > 6)level = 6;
			}
			else if (nokori < 210)
			{
				if (level > 7)level = 7;
			}
			else if (nokori < 300)
			{
				level = 8;
			}
			kotae  = oki_sikou(tesu,kifu,timer_sec,&moto,&saki,&naru,level);
			if (timer_max)
			{
				nokori = timer_max - timer_sec[teban];
				if (nokori < 0)
				{
					if (kotae > 0)
					{
						kotae = 0;
					}
				}
			}
		}

		switch(kotae)
		{
		case 0:		// 
			::PostMessage((HWND)pParam,WM_SASITE,0,-1);
			break;
		case -1:	// (Not define)
		case -2:	// ҂(Not define)
		case -3:	// f(Not define)
			::PostMessage((HWND)pParam,WM_SASITE,0,kotae);
			break;
		default:
			tesu_h = tesu;
			memcpy(men,men_h,100);
			if (naru)
			{
				::PostMessage((HWND)pParam,WM_SASITE,moto,saki + NARU_CODE);
			}
			else
			{
				::PostMessage((HWND)pParam,WM_SASITE,moto,saki);
			}
			break;
		}
		if (kotae > 0)
		{
			kotae = tesu_h - 1;
			if (kotae >= teban_flag)
			{
				kifu2[kotae][0] = kifu[kotae][0];
				kifu2[kotae][1] = kifu[kotae][1];
			}
			sasu(men,teban,moto,saki,naru);
			kifu2[tesu_h][1] = moto;
			if (naru)
			{
				kifu2[tesu_h][0] = saki + NARU_CODE;
			}
			kifu2[tesu_h][0] = saki;
			tesu_h++;
			kifu2[tesu_h][0] = 0;
			oki_ura(men,tesu_h,kifu2,&ura_stop);
		}
	}
	oki_end();
	CloseHandle(hEvent);
	oki_run_flag = 0;
	return(0);
}

void oki_start(HWND m_hWnd)
{
	int		ura_flag;

	if (oki_run_flag)return;

	if (i_man[0] <= 0)
	{
		ura_flag = 1;
	}
	else if (i_man[1] <= 0)
	{
		ura_flag = 1;
	}
	else
	{
		ura_flag = 0;
	}

	if (ura_flag)
	{
		ura_stop = 0;
		strcopy((char *)kifu2,(char *)kifu);
		hEvent   = CreateEvent(NULL,FALSE,FALSE,NULL);
		AfxBeginThread(UraOkiThreadProc,m_hWnd,THREAD_PRIORITY_NORMAL);
	}
	else
	{
		hEvent = CreateEvent(NULL,FALSE,FALSE,NULL);
		AfxBeginThread(OkiThreadProc,m_hWnd,THREAD_PRIORITY_NORMAL);
	}
}

void oki_kick()
{
	if (ura_stop == 0)ura_stop = 1;
	SetEvent(hEvent);
}

void oki_stop()
{
	if (ura_stop >= 0)ura_stop = -1;
	stop_flag = 1;
	SetEvent(hEvent);
}
