/************************/
/*    TumedllDlg.cpp    */
/************************/
#include "stdafx.h"
#include "Oki.h"
#include "TumedllDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

/////////////////////////////////////////////////////////////////////////////
// CTumedllDlg _CAO

IMPLEMENT_DYNAMIC(CTumedllDlg,CDialog)

CTumedllDlg::CTumedllDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTumedllDlg::IDD, pParent)
	, m_jissen(FALSE)
{
	m_dll    = _T("");
	m_ini    = _T("");
	m_tume   = _T("");
	m_end    = _T("");
	m_jissen = FALSE;
}

void CTumedllDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);

	DDX_Text(pDX, IDC_EDIT_DLL, m_dll);
	DDV_MaxChars(pDX, m_dll, 255);
	DDX_Text(pDX, IDC_EDIT_INI, m_ini);
	DDX_Text(pDX, IDC_EDIT_SIKOU, m_tume);
	DDX_Text(pDX, IDC_EDIT_END, m_end);
	DDX_Check(pDX, IDC_CHECK_JISSEN, m_jissen);
}

BEGIN_MESSAGE_MAP(CTumedllDlg, CDialog)
	ON_BN_CLICKED(IDC_BUTTON_DLL, OnButtonDll)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTumedllDlg bZ[W nh

void CTumedllDlg::OnButtonDll() 
{
	if (!UpdateData(TRUE))return;

	CFileDialog		dlg(TRUE,"dll",m_dll,OFN_FILEMUSTEXIST | OFN_HIDEREADONLY,
					"DLL FILES (*.dll)|*.dll|ALL FILES(*.*)|*.*||",NULL);

	dlg.m_ofn.lpstrTitle = "SET l DLL";

	if (dlg.DoModal() == IDOK)
	{
		m_dll = dlg.GetPathName();
		UpdateData(FALSE);
	}
}
