/************************/
/*      s_total.cpp     */
/************************/
#include "stdafx.h"
#include "sente.h"

static char     amari[] = { 0 , 0 , 1 , 2 , 3 , 4 , 5 , 6 , 7 , 8 ,
                                0 , 1 , 2 , 3 , 4 , 5 , 6 , 7 , 8 ,
                                0 , 1 , 2 , 3 , 4 , 5 , 6 , 7 , 8 ,
                                0 , 1 , 2 , 3 , 4 , 5 , 6 , 7 , 8 ,
                                0 , 1 , 2 , 3 , 4 , 5 , 6 , 7 , 8 ,
                                0 , 1 , 2 , 3 , 4 , 5 , 6 , 7 , 8 ,
                                0 , 1 , 2 , 3 , 4 , 5 , 6 , 7 , 8 ,
                                0 , 1 , 2 , 3 , 4 , 5 , 6 , 7 , 8 ,
                                0 , 1 , 2 , 3 , 4 , 5 , 6 , 7 , 8 } ;

static int s_fu(char *men,int cnt,int *m_moto,int *m_saki,int *m_naru,int moto)
{
    int saki;

    saki = moto - 9;
    if (men[saki] > 0)return(cnt);
    m_moto[cnt  ] = moto;
    m_saki[cnt  ] = saki;
    if (saki <= 9)
    {
        m_naru[cnt++] = 1;
    }
    else if(saki <= 27)
	{
	    m_naru[cnt++] = 1;
    	m_moto[cnt  ] = moto;
    	m_saki[cnt  ] = saki;
	    m_naru[cnt++] = 0;
	}
	else
	{
    	m_naru[cnt++] = 0;
	}
	return(cnt);
}

static int s_kyo(char *men,int cnt,int *m_moto,int *m_saki,int *m_naru,int moto)
{
    int saki;

    for (saki = moto - 9 ; saki > 0 ; saki -= 9)
    {
        if (men[saki] > 0)return(cnt);
        m_moto[cnt  ] = moto;
        m_saki[cnt  ] = saki;
        if (saki <= 9)
        {
            m_naru[cnt++] = 1;
            return(cnt);
        }
        if(saki <= 27)
        {
            m_naru[cnt++] = 1;
            m_moto[cnt  ] = moto;
            m_saki[cnt  ] = saki;
        }
        m_naru[cnt++] = 0;
        if (men[saki])return(cnt);
    }
	return(cnt);
}

static int s_kei(char *men,int cnt,int *m_moto,int *m_saki,int *m_naru,int moto)
{
    int saki;
    int j;
    int ix;

    ix = amari[moto];
    for (j = 0 ; j < 2 ; j++)
    {
        if (j == 0)
        {
            if (ix == 0)continue;
            saki = moto - 19;
        }
        else
        {
            if (ix == 8)continue;
            saki = moto - 17;
        }
        if (men[saki] > 0)continue;
        m_moto[cnt  ] = moto;
        m_saki[cnt  ] = saki;
        if (saki <= 18)
        {
            m_naru[cnt++] = 1;
            continue;
        }
        m_naru[cnt++] = 0;
        if(saki > 27)continue;
        m_moto[cnt  ] = moto;
        m_saki[cnt  ] = saki;
        m_naru[cnt++] = 1;
    }
	return(cnt);
}

static int s_gin(char *men,int cnt,int *m_moto,int *m_saki,int *m_naru,int moto)
{
    int saki;
    int j;
    int ix;
    int flag;

    ix = amari[moto];
    for (j = 0 ; j < 5 ; j++)
    {
        flag = 0;
        switch(j)
        {
        case 0:
            if (ix == 0)flag = 1;
            saki = moto - 10;
            if (saki <= 0)flag = 1;
            break;
        case 1:
            saki = moto - 9;
            if (saki <= 0)flag = 1;
            break;
        case 2:
            if (ix == 8)flag = 1;
            saki = moto - 8;
            if (saki <= 0)flag = 1;
            break;
        case 3:
            if (ix == 0)flag = 1;
            saki = moto + 8;
            if (saki > 81)flag = 1;
            break;
        default:
            if (ix == 8)flag = 1;
            saki = moto + 10;
            if (saki > 81)flag = 1;
            break;
        }
        if (flag)continue;
        if (men[saki] > 0)continue;

        if((saki <= 27) || (moto <= 27))
		{
        	m_moto[cnt  ] = moto;
	        m_saki[cnt  ] = saki;
    	    m_naru[cnt++] = 1;
		}
        m_moto[cnt  ] = moto;
        m_saki[cnt  ] = saki;
        m_naru[cnt++] = 0;
    }
	return(cnt);
}

static int s_kin(char *men,int cnt,int *m_moto,int *m_saki,int *m_naru,int moto)
{
    int saki;
    int j;
    int ix;
    int flag;

    ix = amari[moto];
    for (j = 0 ; j < 6 ; j++)
    {
        flag = 0;
        switch (j)
        {
        case 0:
            if (ix == 0)flag = 1;
            saki = moto - 10;
            if (saki <= 0)flag = 1;
            break;
        case 1:
            saki = moto - 9;
            if (saki <= 0)flag = 1;
            break;
        case 2:
            if (ix == 8)flag = 1;
            saki = moto - 8;
            if (saki <= 0)flag = 1;
            break;
        case 3:
            if (ix == 0)flag = 1;
            saki = moto - 1;
            break;
        case 4:
            if (ix == 8)flag = 1;
            saki = moto + 1;
            break;
        default:
            saki = moto + 9;
            if (saki > 81)flag = 1;
            break;
        }
        if (flag)continue;
        if (men[saki] > 0)continue;
        m_moto[cnt  ] = moto;
        m_saki[cnt  ] = saki;
        m_naru[cnt++] = 0;
	}
	return(cnt);
}

static int s_kaku(char *men,int cnt,int *m_moto,int *m_saki,int *m_naru,int moto)
{
    int saki;
    int j;
    int ix;
    int ix_inc;
    int houkou;

    for (j = 0; j < 4; j++)
    {
        switch(j)
        {
        case 0 :
            ix_inc = -1;
            houkou = -10;
            break;
        case 1 :
            ix_inc =  1;
            houkou = -8;
            break;
        case 2 :
            ix_inc = -1;
            houkou =  8;
            break;
        default:
            ix_inc =  1;
            houkou = 10;
            break;
        }
        ix = amari[moto];
        for (saki = moto + houkou ; saki > 0 ; saki += houkou)
        {
            if (saki > 81)break;
            ix += ix_inc;
            if (ix < 0)break;
            if (ix > 8)break;
            if (men[saki] > 0)break;
            if((saki <= 27) || (moto <= 27))
            {
				m_moto[cnt  ] = moto;
				m_saki[cnt  ] = saki;
				m_naru[cnt++] = 1;
            }
            m_moto[cnt  ] = moto;
            m_saki[cnt  ] = saki;
            m_naru[cnt++] = 0;
            if (men[saki])break;
        }
    }
	return(cnt);
}

static int s_hi(char *men,int cnt,int *m_moto,int *m_saki,int *m_naru,int moto)
{
    int		saki;
    int		ix;
	int		ip_ok;

	if (moto <= 27)
	{
		saki = moto - 9;
		while(saki > 0)
		{
			if (men[saki] > 0)break;
			m_moto[cnt  ] = moto;
			m_saki[cnt  ] = saki;
			m_naru[cnt++] = 1;
			m_moto[cnt  ] = moto;
			m_saki[cnt  ] = saki;
			m_naru[cnt++] = 0;
			if (men[saki])break;
			saki -= 9;
		}

		saki = moto + 9;
		while(saki <= 81)
		{
			if (men[saki] > 0)break;
			m_moto[cnt  ] = moto;
			m_saki[cnt  ] = saki;
			m_naru[cnt++] = 1;
			m_moto[cnt  ] = moto;
			m_saki[cnt  ] = saki;
			m_naru[cnt++] = 0;
			if (men[saki])break;
			saki += 9;
		}

		ix = amari[moto];
		ip_ok = saki = moto;
		while(ix < 8)
		{
			ix++;
			saki++;
			if (men[saki] > 0)break;
			ip_ok = saki;
			if (men[saki])break;
		}
		while(ip_ok != moto)
		{
			m_moto[cnt  ] = moto;
			m_saki[cnt  ] = ip_ok;
			m_naru[cnt++] = 1;
			m_moto[cnt  ] = moto;
			m_saki[cnt  ] = ip_ok;
			m_naru[cnt++] = 0;
			ip_ok--;
		}

		ix = amari[moto];
		ip_ok = saki = moto;
		while(ix > 0)
		{
			ix--;
			saki--;
			if (men[saki] > 0)break;
			ip_ok = saki;
			if (men[saki])break;
		}
		while(ip_ok != moto)
		{
			m_moto[cnt  ] = moto;
			m_saki[cnt  ] = ip_ok;
			m_naru[cnt++] = 1;
			m_moto[cnt  ] = moto;
			m_saki[cnt  ] = ip_ok;
			m_naru[cnt++] = 0;
			ip_ok++;
		}
    }
	else
	{
		saki = moto - 9;
		while(saki > 0)
		{
			if (men[saki] > 0)break;
			if (saki <= 27)
			{
				m_moto[cnt  ] = moto;
				m_saki[cnt  ] = saki;
				m_naru[cnt++] = 1;
			}
			m_moto[cnt  ] = moto;
			m_saki[cnt  ] = saki;
			m_naru[cnt++] = 0;
			if (men[saki])break;
			saki -= 9;
		}

		saki = moto + 9;
		while(saki <= 81)
		{
			if (men[saki] > 0)break;
			m_moto[cnt  ] = moto;
			m_saki[cnt  ] = saki;
			m_naru[cnt++] = 0;
			if (men[saki])break;
			saki += 9;
		}

		ix = amari[moto];
		ip_ok = saki = moto;
		while(ix < 8)
		{
			ix++;
			saki++;
			if (men[saki] > 0)break;
			ip_ok = saki;
			if (men[saki])break;
		}
		while(ip_ok != moto)
		{
			m_moto[cnt  ] = moto;
			m_saki[cnt  ] = ip_ok;
			m_naru[cnt++] = 0;
			ip_ok--;
		}

		ix = amari[moto];
		ip_ok = saki = moto;
		while(ix > 0)
		{
			ix--;
			saki--;
			if (men[saki] > 0)break;
			ip_ok = saki;
			if (men[saki])break;
		}
		while(ip_ok != moto)
		{
			m_moto[cnt  ] = moto;
			m_saki[cnt  ] = ip_ok;
			m_naru[cnt++] = 0;
			ip_ok++;
		}
    }
	return(cnt);
}

static int s_ou(char *men,int cnt,int *m_moto,int *m_saki,int *m_naru,int moto)
{
    int saki;
    int ix;

    ix = amari[moto];
    if (moto > 9)
    {
        saki = moto - 9;
        if (men[saki] <= 0)
        {
			m_moto[cnt  ] = moto;
            m_saki[cnt  ] = saki;
            m_naru[cnt++] = 0;
        }
        if (ix)
        {
            saki = moto - 10;
            if (men[saki] <= 0)
            {
            	m_moto[cnt  ] = moto;
            	m_saki[cnt  ] = saki;
            	m_naru[cnt++] = 0;
			}
        }
        if (ix != 8)
        {
            saki = moto - 8;
            if (men[saki] <= 0)
            {
				m_moto[cnt  ] = moto;
	            m_saki[cnt  ] = saki;
    	        m_naru[cnt++] = 0;
            }
        }
    }

    if (ix)
    {
        saki = moto - 1;
        if (men[saki] <= 0)
        {
			m_moto[cnt  ] = moto;
			m_saki[cnt  ] = saki;
			m_naru[cnt++] = 0;
        }
    }

    if (ix != 8)
    {
        saki = moto + 1;
        if (men[saki] <= 0)
        {
            m_moto[cnt  ] = moto;
            m_saki[cnt  ] = saki;
            m_naru[cnt++] = 0;
        }
    }

    if (moto <= 72)
    {
        saki = moto + 9;
        if (men[saki] <= 0)
        {
            m_moto[cnt  ] = moto;
            m_saki[cnt  ] = saki;
            m_naru[cnt++] = 0;
        }

        if (ix)
        {
            saki = moto + 8;
            if (men[saki] <= 0)
            {
	            m_moto[cnt  ] = moto;
	            m_saki[cnt  ] = saki;
    	        m_naru[cnt++] = 0;
            }
        }

        if (ix != 8)
        {
            saki = moto + 10;
            if (men[saki] <= 0)
            {
	            m_moto[cnt  ] = moto;
	            m_saki[cnt  ] = saki;
    	        m_naru[cnt++] = 0;
            }
        }
    }
	return(cnt);
}

static int s_uma(char *men,int cnt,int *m_moto,int *m_saki,int *m_naru,int moto)
{
    int saki;
    int j;
    int houkou;
    int ix;
    int ix_inc;

    for (j = 0; j < 4; j++)
    {
        switch(j)
        {
        case 0 :
            ix_inc = -1;
            houkou = -10;
            break;
        case 1 :
            ix_inc =  1;
            houkou = -8;
            break;
        case 2 :
            ix_inc = -1;
            houkou =  8;
            break;
        default:
            ix_inc =  1;
            houkou = 10;
            break;
        }
        ix = amari[moto];
        for (saki = moto + houkou ; saki > 0 ; saki += houkou)
        {
            if (saki > 81)break;
            ix += ix_inc;
            if (ix < 0)break;
            if (ix > 8)break;
            if (men[saki] > 0)break;
            m_moto[cnt  ] = moto;
            m_saki[cnt  ] = saki;
            m_naru[cnt++] = 0;
            if (men[saki])break;
        }
    }

    for (j = 0; j < 4; j++)
    {
        switch(j)
        {
        case 0 :
            houkou = ix_inc = -1;
            break;
        case 1 :
            ix_inc =  0;
            houkou = -9;
            break;
        case 2 :
            houkou =  9;
            break;
        default:
            houkou = ix_inc =  1;
            break;
        }
        ix = amari[moto];
        saki = moto + houkou;
        if(saki <= 0 )continue;
        if(saki > 81)continue;
        ix += ix_inc;
        if (ix < 0)continue;
        if (ix > 8)continue;
        if (men[saki] > 0)continue;
        m_moto[cnt  ] = moto;
        m_saki[cnt  ] = saki;
        m_naru[cnt++] = 0;
    }
	return(cnt);
}

static int s_ryu(char *men,int cnt,int *m_moto,int *m_saki,int *m_naru,int moto)
{
    int saki;
    int j;
    int ix;
    int ix_inc;
    int houkou;

    for (j = 0; j < 4; j++)
    {
        switch(j)
        {
        case 0 :
            ix_inc =  0;
            houkou = -9;
            break;
        case 1 :
            houkou =  9;
            break;
        case 2 :
            houkou = ix_inc =  1;
            break;
        default:
            houkou = ix_inc = -1;
            break;
        }
        ix = amari[moto];
        for (saki = moto + houkou ; saki > 0 ; saki += houkou)
        {
            if (saki > 81)break;
            ix += ix_inc;
            if (ix < 0)break;
            if (ix > 8)break;
            if (men[saki] > 0)break;
            m_moto[cnt  ] = moto;
            m_saki[cnt  ] = saki;
            m_naru[cnt++] = 0;
            if (men[saki])break;
        }
    }

    for (j = 0; j < 4; j++)
    {
        switch(j)
        {
        case 0 :
            ix_inc = -1;
            houkou = -10;
            break;
        case 1 :
            houkou =  8;
            break;
        case 2 :
            ix_inc =  1;
            houkou = -8;
            break;
        default:
            houkou =  10;
            break;
        }
        saki = moto + houkou;
        if(saki <= 0 )continue;
        if(saki > 81)continue;
        ix = amari[moto] + ix_inc;
        if (ix < 0)continue;
        if (ix > 8)continue;
        if (men[saki] > 0)continue;
        m_moto[cnt  ] = moto;
        m_saki[cnt  ] = saki;
        m_naru[cnt++] = 0;
	}
	return(cnt);
}

int s_total(char *men,int *m_moto,int *m_saki,int *m_naru)
{
	int		moto;
	int		saki;
	int		cnt;
	int		is;
	int		flag;
	int		koma;
	int		ix;

	cnt = 0;

	/* Ԃł */
    if (MS7)
    {
        for (saki = 1 ; saki <= 27 ; saki++)
        {
			if (men[saki] == 0)
            {
				m_moto[cnt  ] = UCHI_HI;
                m_saki[cnt++] = saki;
			}
		}
	}

    for ( moto = 1 ; moto <= 81 ; moto++)
    {
        switch (men[moto])
        {
        case SFU:                         /*  */
            cnt = s_fu(men,cnt,m_moto,m_saki,m_naru,moto);
            break;
        case SKYO:                         /*  */
            cnt = s_kyo(men,cnt,m_moto,m_saki,m_naru,moto);
            break;
        case SKEI:                         /* j */
            cnt = s_kei(men,cnt,m_moto,m_saki,m_naru,moto);
            break;
        case SGIN:                         /*  */
            cnt = s_gin(men,cnt,m_moto,m_saki,m_naru,moto);
            break;
        case SKIN:                         /*  */
        case STO:						   /* Ƌ */
        case SNKYO:                        /*  */
        case SNKEI:                        /* j */
        case SNGIN:                        /*  */
            cnt = s_kin(men,cnt,m_moto,m_saki,m_naru,moto);
            break;
        case SKAKU:                         /* p */
            cnt = s_kaku(men,cnt,m_moto,m_saki,m_naru,moto);
            break;
        case SHI:                         /*  */
            cnt = s_hi(men,cnt,m_moto,m_saki,m_naru,moto);
            break;
        case SOU:                         /*  */
            cnt = s_ou(men,cnt,m_moto,m_saki,m_naru,moto);
            break;
        case SUMA:                        /* n */
            cnt = s_uma(men,cnt,m_moto,m_saki,m_naru,moto);
            break;
        case SRYU:                        /*  */
            cnt = s_ryu(men,cnt,m_moto,m_saki,m_naru,moto);
            break;
        default:
            break;
        }
    }

	/* ł */
    if (MS1)                   /* ł */
    {
        for (ix = 10 ; ix <= 18 ; ix++)
        {
            flag = 0;                   /* tO */
            for (saki = ix ; saki <= 81 ; saki += 9)
            {
                if (men[saki] == SFU)
                {
                    flag = 2;
                    break;
                }
            }
            if(flag == 2)continue;
            for (saki = ix ; saki <= 81 ; saki += 9)
            {
                if (men[saki] == 0)
                {
                    m_moto[cnt  ] = UCHI_FU;
                    m_saki[cnt++] = saki;
                }
            }
        }
    }

    for (koma = 2 ; koma <= 7 ; koma++)
    {
        if (men[koma + 82] == 0)continue;
        switch (koma)
        {
        case 2:                         /*  */
            is = 10;
            break;
        case 3:                         /* j */
            is = 19;
            break;
		case 7:
			is = 28;					/*  */
			break;
        default:
            is = 1;
            break;
        }
		moto = UCHI_KOMA + koma;
        for (saki = is ; saki <= 81 ; saki++)
        {
            if (men[saki])continue;
            m_moto[cnt  ] = moto;
            m_saki[cnt++] = saki;
		}
	}
	return(cnt);
}

static int g_fu(char *men,int cnt,int *m_moto,int *m_saki,int *m_naru,int moto)
{
    int saki;

    saki = moto + 9;
    if (men[saki] < 0)return(cnt);
    m_moto[cnt] = moto;
    m_saki[cnt] = saki;
    if (saki > 72)
    {
        m_naru[cnt++] = 1;
    }
	else if (saki > 54)
	{
		m_naru[cnt++] = 1;
		m_moto[cnt  ] = moto;
		m_saki[cnt  ] = saki;
		m_naru[cnt++] = 0;
    }
	else
	{
		m_naru[cnt++] = 0;
	}
	return(cnt);
}

static int g_kyo(char *men,int cnt,int *m_moto,int *m_saki,int *m_naru,int moto)
{
    int saki;

    for (saki = moto + 9 ; saki <= 81 ; saki += 9)
    {
        if (men[saki] < 0)return(cnt);
        m_moto[cnt] = moto;
        m_saki[cnt] = saki;
        if (saki > 72)
        {
			m_naru[cnt++] = 1;
			return(cnt);
        }
        if(saki > 54)
        {
            m_naru[cnt++] = 1;
			m_moto[cnt  ] = moto;
            m_saki[cnt  ] = saki;
		}
        m_naru[cnt++] = 0;
        if (men[saki])return(cnt);
    }
	return(cnt);
}

static int g_kei(char *men,int cnt,int *m_moto,int *m_saki,int *m_naru,int moto)
{
	int saki;
    int j;
    int ix;

    ix = amari[moto];
    for (j = 0 ; j < 2 ; j++)
    {
        if (j == 0)
        {
            if (ix == 0)continue;
            saki = moto + 17;
        }
        else
        {
            if (ix == 8)return(cnt);
            saki = moto + 19;
        }
        if (men[saki] < 0)continue;
        m_moto[cnt] = moto;
        m_saki[cnt] = saki;
        if (saki > 63)
        {
            m_naru[cnt++] = 1;
            continue;
        }
        m_naru[cnt++] = 0;
        if(saki <= 54)continue;
        m_moto[cnt  ] = moto;
        m_saki[cnt  ] = saki;
        m_naru[cnt++] = 1;
    }
	return(cnt);
}

static int g_gin(char *men,int cnt,int *m_moto,int *m_saki,int *m_naru,int moto)
{
    int saki;
    int j;
    int ix;
    int flag;

    ix = amari[moto];
    for (j = 0 ; j < 5 ; j++)
    {
        flag = 0;
        switch(j)
        {
        case 0:
            if (ix == 0)flag = 1;
            saki = moto + 8;
            if (saki > 81)flag = 1;
            break;
        case 1:
            saki = moto + 9;
            if (saki > 81)flag = 1;
            break;
        case 2:
            if (ix == 8)flag = 1;
            saki = moto + 10;
            if (saki > 81)flag = 1;
            break;
        case 3:
            if (ix == 0)flag = 1;
            saki = moto - 10;
            if (saki <= 0)flag = 1;
            break;
        default:
            if (ix == 8)flag = 1;
            saki = moto - 8;
            if (saki <= 0)flag = 1;
            break;
        }
        if (flag)continue;
        if (men[saki] < 0)continue;
        if((saki > 54) || (moto > 54))
		{
        	m_moto[cnt  ] = moto;
        	m_saki[cnt  ] = saki;
        	m_naru[cnt++] = 1;
		}
		m_moto[cnt  ] = moto;
        m_saki[cnt  ] = saki;
        m_naru[cnt++] = 0;
	}
	return(cnt);
}

static int g_kin(char *men,int cnt,int *m_moto,int *m_saki,int *m_naru,int moto)
{
    int saki;
    int j;
    int ix;
    int flag;

    ix = amari[moto];
    for (j = 0 ; j < 6 ; j++)
    {
        flag = 0;
        switch (j)
        {
        case 0:
            if (ix == 0)flag = 1;
            saki = moto + 8;
            if (saki > 81)flag = 1;
            break;
        case 1:
            saki = moto + 9;
            if (saki > 81)flag = 1;
            break;
        case 2:
            if (ix == 8)flag = 1;
            saki = moto + 10;
            if (saki > 81)flag = 1;
            break;
        case 3:
            if (ix == 0)flag = 1;
            saki = moto - 1;
            break;
        case 4:
            if (ix == 8)flag = 1;
            saki = moto + 1;
            break;
        default:
            saki = moto - 9;
            if (saki <= 0)flag = 1;
            break;
        }
        if (flag)continue;
        if (men[saki] < 0)continue;
        m_moto[cnt  ] = moto;
        m_saki[cnt  ] = saki;
        m_naru[cnt++] = 0;
    }
	return(cnt);
}

static int g_kaku(char *men,int cnt,int *m_moto,int *m_saki,int *m_naru,int moto)
{
    int saki;
    int j;
    int ix;
    int ix_inc;
    int houkou;

    for (j = 0; j < 4; j++)
    {
        switch(j)
        {
        case 0 :
            ix_inc = -1;
            houkou = -10;
            break;
        case 1 :
            ix_inc =  1;
            houkou = -8;
            break;
        case 2 :
            ix_inc = -1;
            houkou =  8;
            break;
        default:
            ix_inc =  1;
            houkou =  10;
            break;
        }
        ix = amari[moto];
        for (saki = moto + houkou ; saki > 0 ; saki += houkou)
        {
            if (saki > 81)break;
            ix += ix_inc;
            if (ix < 0)break;
            if (ix > 8)break;
            if (men[saki] < 0)break;
            if((saki > 54) || (moto > 54))
            {
                m_moto[cnt  ] = moto;
                m_saki[cnt  ] = saki;
                m_naru[cnt++] = 1;
            }
            m_moto[cnt  ] = moto;
            m_saki[cnt  ] = saki;
            m_naru[cnt++] = 0;
            if (men[saki])break;
        }
    }
	return(cnt);
}

static int g_hi(char *men,int cnt,int *m_moto,int *m_saki,int *m_naru,int moto)
{
    int		saki;
    int		ix;
	int		ip_ok;

	if (moto > 54)
	{
		saki = moto + 9;
		while(saki <= 81)
		{
			if (men[saki] < 0)break;
			m_moto[cnt  ] = moto;
			m_saki[cnt  ] = saki;
			m_naru[cnt++] = 1;
			m_moto[cnt  ] = moto;
			m_saki[cnt  ] = saki;
			m_naru[cnt++] = 0;
			if (men[saki])break;
			saki += 9;
		}

		saki = moto - 9;
		while(saki > 0)
		{
			if (men[saki] < 0)break;
			m_moto[cnt  ] = moto;
			m_saki[cnt  ] = saki;
			m_naru[cnt++] = 1;
			m_moto[cnt  ] = moto;
			m_saki[cnt  ] = saki;
			m_naru[cnt++] = 0;
			if (men[saki])break;
			saki -= 9;
		}

		ix = amari[moto];
		ip_ok = saki = moto;
		while(ix < 8)
		{
			ix++;
			saki++;
			if (men[saki] < 0)break;
			ip_ok = saki;
			if (men[saki])break;
		}
		while(ip_ok != moto)
		{
			m_moto[cnt  ] = moto;
			m_saki[cnt  ] = ip_ok;
			m_naru[cnt++] = 1;
			m_moto[cnt  ] = moto;
			m_saki[cnt  ] = ip_ok;
			m_naru[cnt++] = 0;
			ip_ok--;
		}

		ix = amari[moto];
		ip_ok = saki = moto;
		while(ix > 0)
		{
			ix--;
			saki--;
			if (men[saki] < 0)break;
			ip_ok = saki;
			if (men[saki])break;
		}
		while(ip_ok != moto)
		{
			m_moto[cnt  ] = moto;
			m_saki[cnt  ] = ip_ok;
			m_naru[cnt++] = 1;
			m_moto[cnt  ] = moto;
			m_saki[cnt  ] = ip_ok;
			m_naru[cnt++] = 0;
			ip_ok++;
		}
    }
	else
	{
		saki = moto + 9;
		while(saki <= 81)
		{
			if (men[saki] < 0)break;
			if (saki > 54)
			{
				m_moto[cnt  ] = moto;
				m_saki[cnt  ] = saki;
				m_naru[cnt++] = 1;
			}
			m_moto[cnt  ] = moto;
			m_saki[cnt  ] = saki;
			m_naru[cnt++] = 0;
			if (men[saki])break;
			saki += 9;
		}

		saki = moto - 9;
		while(saki > 0)
		{
			if (men[saki] < 0)break;
			m_moto[cnt  ] = moto;
			m_saki[cnt  ] = saki;
			m_naru[cnt++] = 0;
			if (men[saki])break;
			saki -= 9;
		}

		ix = amari[moto];
		ip_ok = saki = moto;
		while(ix < 8)
		{
			ix++;
			saki++;
			if (men[saki] < 0)break;
			ip_ok = saki;
			if (men[saki])break;
		}
		while(ip_ok != moto)
		{
			m_moto[cnt  ] = moto;
			m_saki[cnt  ] = ip_ok;
			m_naru[cnt++] = 0;
			ip_ok--;
		}

		ix = amari[moto];
		ip_ok = saki = moto;
		while(ix > 0)
		{
			ix--;
			saki--;
			if (men[saki] < 0)break;
			ip_ok = saki;
			if (men[saki])break;
		}
		while(ip_ok != moto)
		{
			m_moto[cnt  ] = moto;
			m_saki[cnt  ] = ip_ok;
			m_naru[cnt++] = 0;
			ip_ok++;
		}
    }
	return(cnt);
}

static int g_ou(char *men,int cnt,int *m_moto,int *m_saki,int *m_naru,int moto)
{
    int saki;
    int ix;

    ix = amari[moto];
    if (moto <= 72)
    {
        saki = moto + 9;
        if (men[saki] >= 0)
        {
            m_moto[cnt  ] = moto;
            m_saki[cnt  ] = saki;
            m_naru[cnt++] = 0;
        }
        if (ix != 8)
        {
            saki = moto + 10;
            if (men[saki] >= 0)
            {
	            m_moto[cnt  ] = moto;
    	        m_saki[cnt  ] = saki;
        	    m_naru[cnt++] = 0;
            }
        }
        if (ix)
        {
            saki = moto + 8;
            if (men[saki] >= 0)
            {
			    m_moto[cnt  ] = moto;
	            m_saki[cnt  ] = saki;
    	        m_naru[cnt++] = 0;
            }
        }
    }

    if (ix)
    {
        saki = moto - 1;
        if (men[saki] >= 0)
        {
	        m_moto[cnt  ] = moto;
            m_saki[cnt  ] = saki;
            m_naru[cnt++] = 0;
        }
    }

    if (ix != 8)
    {
        saki = moto + 1;
        if (men[saki] >= 0)
        {
            m_moto[cnt  ] = moto;
            m_saki[cnt  ] = saki;
            m_naru[cnt++] = 0;
        }
    }

    if (moto > 9)
    {
        saki = moto - 9;
        if (men[saki] >= 0)
        {
            m_moto[cnt  ] = moto;
            m_saki[cnt  ] = saki;
            m_naru[cnt++] = 0;
        }
        if (ix)
        {
            saki = moto - 10;
            if (men[saki] >= 0)
            {
	            m_moto[cnt  ] = moto;
	            m_saki[cnt  ] = saki;
    	        m_naru[cnt++] = 0;
            }
        }
        if (ix != 8)
        {
            saki = moto - 8;
            if (men[saki] >= 0)
            {
	            m_moto[cnt  ] = moto;
	            m_saki[cnt  ] = saki;
    	        m_naru[cnt++] = 0;
            }
        }
    }
	return(cnt);
}

static int g_uma(char *men,int cnt,int *m_moto,int *m_saki,int *m_naru,int moto)
{
    int saki;
    int j;
    int ix;
    int ix_inc;
    int houkou;

    for (j = 0; j < 4; j++)
    {
        switch(j)
        {
        case 0 :
            ix_inc = -1;
            houkou = -10;
            break;
        case 1 :
            ix_inc =  1;
            houkou = -8;
            break;
        case 2 :
            ix_inc = -1;
            houkou =  8;
            break;
        default:
            ix_inc =  1;
            houkou =  10;
            break;
        }
        ix = amari[moto];
        for (saki = moto + houkou ; saki > 0 ; saki += houkou)
        {
            if (saki > 81)break;
            ix += ix_inc;
            if (ix < 0)break;
            if (ix > 8)break;
            if (men[saki] < 0)break;
            m_moto[cnt  ] = moto;
            m_saki[cnt  ] = saki;
            m_naru[cnt++] = 0;
            if (men[saki])break;
        }
    }

    for (j = 0; j < 4; j++)
    {
        switch(j)
        {
        case 0 :
            saki = moto - 1;
            ix  = amari[moto] - 1;
            break;
        case 1 :
            saki = moto - 9;
            ix++;
            break;
        case 2 :
            saki = moto + 9;
            break;
        default:
            saki = moto + 1;
            ix++;
            break;
        }
        if(saki <= 0 )continue;
        if(saki > 81)continue;
        if (ix < 0)continue;
        if (ix > 8)continue;
        if (men[saki] < 0)continue;
        m_moto[cnt  ] = moto;
        m_saki[cnt  ] = saki;
        m_naru[cnt++] = 0;
    }
	return(cnt);
}

static int g_ryu(char *men,int cnt,int *m_moto,int *m_saki,int *m_naru,int moto)
{
    int saki;
    int j;
    int ix;
    int ix_inc;
    int houkou;

    for (j = 0; j < 4; j++)
    {
        switch(j)
        {
        case 0:
            houkou = ix_inc =  1;
            break;
        case 1:
            houkou = ix_inc = -1;
            break;
        case 2:
            ix_inc =  0;
            houkou = -9;
            break;
        default:
            ix_inc =  0;
            houkou =  9;
            break;
        }
        ix = amari[moto];
        for (saki = moto + houkou ; saki > 0 ; saki += houkou)
        {
            if (saki > 81)break;
            ix += ix_inc;
            if (ix < 0)break;
            if (ix > 8)break;
            if (men[saki] < 0)break;
            m_moto[cnt  ] = moto;
            m_saki[cnt  ] = saki;
            m_naru[cnt++] = 0;
            if (men[saki])break;
        }
    }

    for (j = 0; j < 4; j++)
    {
        switch(j)
        {
        case 0 :
            ix  = amari[moto] - 1;
            saki = moto - 10;
            break;
        case 1 :
            saki = moto + 8;
            break;
        case 2 :
            ix += 2;
            saki = moto - 8;
            break;
        default:
            saki = moto + 10;
            break;
        }
        if (ix > 8)break;
        if (ix < 0)continue;
        if(saki <= 0 )continue;
        if(saki > 81)continue;
        if (men[saki] < 0)continue;
        m_moto[cnt  ] = moto;
        m_saki[cnt  ] = saki;
        m_naru[cnt++] = 0;
    }
	return(cnt);
}

int g_total(char *men,int *m_moto,int *m_saki,int *m_naru)
{
	int		moto;
	int		saki;
	int		cnt;
	int		ie;
	int		flag;
	int		koma;
	int		ix;

	cnt = 0;

	/* Ԃł */
	if (MG7)
	{
		for (saki = 81 ; saki > 54 ; saki--)
		{
			if (men[saki] == 0)
			{
				m_moto[cnt  ] = UCHI_HI;
				m_saki[cnt++] = saki;
			}
		}
	}

    for ( moto = 81 ; moto > 0 ; moto--)
    {
		switch (men[moto])
        {
        case GFU:                        /*  */
            cnt = g_fu(men,cnt,m_moto,m_saki,m_naru,moto);
            break;
        case GKYO:                        /*  */
            cnt = g_kyo(men,cnt,m_moto,m_saki,m_naru,moto);
            break;
        case GKEI:                        /* j */
            cnt = g_kei(men,cnt,m_moto,m_saki,m_naru,moto);
            break;
        case GGIN:                        /*  */
            cnt = g_gin(men,cnt,m_moto,m_saki,m_naru,moto);
            break;
        case GKIN:                        /*  */
        case GTO:						  /* Ƌ */
        case GNKYO:                       /*  */
        case GNKEI:                       /* j */
        case GNGIN:                       /*  */
            cnt = g_kin(men,cnt,m_moto,m_saki,m_naru,moto);
            break;
        case GKAKU:                      /* p */
            cnt = g_kaku(men,cnt,m_moto,m_saki,m_naru,moto);
            break;
        case GHI:                        /*  */
            cnt = g_hi(men,cnt,m_moto,m_saki,m_naru,moto);
            break;
        case GOU:                        /*  */
            cnt = g_ou(men,cnt,m_moto,m_saki,m_naru,moto);
            break;
        case GUMA:                       /* n */
            cnt = g_uma(men,cnt,m_moto,m_saki,m_naru,moto);
            break;
        case GRYU:                       /*  */
            cnt = g_ryu(men,cnt,m_moto,m_saki,m_naru,moto);
            break;
        default:
            break;
        }
    }

	/* ł */
    if (MG1)                   /* ł */
    {
        for (ix = 1 ; ix <= 9 ; ix++)
        {
            flag = 0;                   /* tO */
            for (saki = ix ; saki <= 72 ; saki += 9)
            {
                if (men[saki] == GFU)
                {
                    flag = 2;
                    break;
                }
            }
            if(flag == 2)continue;
            for (saki = ix ; saki <= 72 ; saki += 9)
            {
                if (men[saki] == 0)
                {
                    m_moto[cnt  ] = UCHI_FU;
                    m_saki[cnt++] = saki;
                }
            }
        }
    }
    for (koma = 2 ; koma <= 7 ; koma++)
    {
        if (men[koma + 90] == 0)continue;
        switch (koma)
        {
        case 2:                         /*  */
            ie = 72;
            break;
        case 3:                         /* j */
            ie = 63;
            break;
		case 7:							/*  */
			ie = 54;
			break;
        default:
            ie = 81;
            break;
        }
		moto = UCHI_KOMA + koma;
        for (saki = ie ; saki >= 1 ; saki--)
        {
            if (men[saki])continue;
            m_moto[cnt  ] = moto;
            m_saki[cnt++] = saki;
		}
	}
	return(cnt);
}
