/************************/
/*     CsadllDlg.cpp    */
/************************/
#include "stdafx.h"
#include "Oki.h"
#include "CsadllDlg.h"
#include "FolderDialog.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

extern char	Current_Dir[];

/////////////////////////////////////////////////////////////////////////////
// CCsadllDlg _CAO

IMPLEMENT_DYNAMIC(CCsadllDlg,CDialog)

CCsadllDlg::CCsadllDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CCsadllDlg::IDD, pParent)
{
	m_dll   = _T("sikou.dll");
	m_ini   = _T("sikou_ini");
	m_sikou = _T("sikou");
	m_end   = _T("sikou_end");
	m_dir   = _T("");
	m_flag = FALSE;
}

void CCsadllDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Text(pDX, IDC_EDIT_DLL, m_dll);
	DDV_MaxChars(pDX, m_dll, 255);
	DDX_Text(pDX, IDC_EDIT_INI, m_ini);
	DDV_MaxChars(pDX, m_ini, 31);
	DDX_Text(pDX, IDC_EDIT_SIKOU, m_sikou);
	DDV_MaxChars(pDX, m_sikou, 31);
	DDX_Text(pDX, IDC_EDIT_END, m_end);
	DDV_MaxChars(pDX, m_end, 31);
	DDX_Text(pDX, IDC_EDIT_DIR, m_dir);
	DDV_MaxChars(pDX, m_dir, 255);
	DDX_Check(pDX, IDC_CHECK_FLAG, m_flag);
}

BEGIN_MESSAGE_MAP(CCsadllDlg, CDialog)
	ON_BN_CLICKED(IDC_BUTTON_DLL, OnButtonDll)
	ON_BN_CLICKED(IDC_BUTTON_DEFAULT, OnButtonDefault)
	ON_BN_CLICKED(IDC_BUTTON_DIR, OnButtonDir)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCsadllDlg bZ[W nh

void CCsadllDlg::OnButtonDll() 
{
	if (!UpdateData(TRUE))return;

	CFileDialog		dlg(TRUE,"dll",m_dll,OFN_FILEMUSTEXIST | OFN_HIDEREADONLY,
					"DLL FILES (*.dll)|*.dll|ALL FILES(*.*)|*.*||",NULL);

	dlg.m_ofn.lpstrTitle = "SET CSA DLL";

	if (dlg.DoModal() == IDOK)
	{
		m_dll = dlg.GetPathName();
		UpdateData(FALSE);
	}
}

void CCsadllDlg::OnButtonDefault() 
{
	if (!UpdateData(TRUE))return;

	m_ini   = _T("sikou_ini");
	m_sikou = _T("sikou");
	m_end   = _T("sikou_end");

	UpdateData(FALSE);
}

void CCsadllDlg::OnButtonDir() 
{
	char	name[_MAX_PATH];

	if (!UpdateData(TRUE))return;

	strcpy_s(name,m_dir);
	if (name[0] == NULL)
	{
		strcpy_s(name,Current_Dir);
	}
	CFolderDialog	dlg(name,this);

	if (dlg.DoModal() == IDOK)
	{
		m_dir = dlg.GetFolderName();
		UpdateData(FALSE);
	}
}
