/************************/
/*      Rs232c.cpp      */
/************************/
#include "stdafx.h"
#include "sente.h"

extern int total(char *men,int *m_moto,int *m_saki,int *m_naru,
					int tesu,unsigned char kifu[][2]);
extern void strcopy(char *s1,char *s2);

extern int				chudan_flag;
extern int				tesu;
extern char				men_h[];
extern unsigned char	kifu[][2];

static char *koma_kind[] =
                { "FU" , "KY" , "KE" , "GI" , "KI" , "KA" , "HI" , "OU" ,
                  "TO" , "NY" , "NK" , "NG" , "  " , "UM" , "RY" };
static char		com_name[8];
static int		ireq;
static HANDLE	hEvent;
static char		smoji[16];
char			rs_message[40];

/******************************/
/* qr|QRQb@o */
/******************************/
static void rs_puts(HANDLE hCom,char *s)
{
	DWORD	len;
	DWORD	len2;

	len = strlen(s);
	WriteFile(hCom,s,len,&len2,NULL);
}

/******************************/
/* qr|QRQb@ */
/******************************/
static int rs_gets(HANDLE hCom,char *s)
{
    int         i;
	DWORD		j;
	DWORD		len;
	DWORD		ierr;
	char		c;
	COMSTAT		stat;
	char		moji[16];

	i = 0;
	c = 0;
	while(i < 14)
	{
		if (i)
		{
			Sleep(50);
		}
		else
		{
			Sleep(314);
		}
		if (chudan_flag)break;
		ClearCommError(hCom,&ierr,&stat);
		if (stat.cbInQue > 0)
		{
			if (stat.cbInQue > 14)stat.cbInQue = 14;
			ReadFile(hCom,moji,stat.cbInQue,&len,NULL);
			if (len < 0)break;
			for (j = 0; j < len ; j++)
			{
				s[i++] = c = moji[j];
				if (i >= 14)break;
				if (c == 0x0a)break;
			}
			if (c == 0x0a)break;
		}
	}
	s[i] = 0;
	return(i);
}

/*****************/
/* RS232C THREAD */
/*****************/

static UINT Rs232cThreadProc(LPVOID pParam)
{
	int		i;
	int		iend;
	int		cnt;
	int		moto;
	int		saki;
	int		naru;
	int		koma;
	int		koma_old;
	int		ix_old;
	int		iy_old;
	int		ix_new;
	int		iy_new;
	int		kotae;
	BOOL	fSuccess;
	DCB		dcb;
	HANDLE	hCom;
	int		m_moto[600];
	int		m_saki[600];
	int		m_naru[600];
	char	moji[16];

	hCom = CreateFile(com_name,
					GENERIC_READ | GENERIC_WRITE,
					0,
					NULL,
					OPEN_EXISTING,
					NULL,
					NULL);

	if (hCom == INVALID_HANDLE_VALUE)
	{
		sprintf_s(rs_message,"(%s)I[vɎs܂B",com_name);
		CloseHandle(hEvent);
		hEvent = NULL;
		return(1);
	}

	fSuccess = GetCommState(hCom,&dcb);
	if (!fSuccess)
	{
		strcopy(rs_message,"DCB쐬Ɏs܂B");
		CloseHandle(hCom);
		CloseHandle(hEvent);
		hEvent = NULL;
		return(2);
	}

	dcb.BaudRate = CBR_1200;
	dcb.ByteSize = 8;
	dcb.Parity   = NOPARITY;
	dcb.StopBits = ONESTOPBIT;

	fSuccess = SetCommState(hCom,&dcb);
	if (!fSuccess)
	{
		strcopy(rs_message,"DCBݒɎs܂B");
		CloseHandle(hCom);
		CloseHandle(hEvent);
		hEvent = NULL;
		return(3);
	}

	iend = 1;
	while(iend)
	{
		WaitForSingleObject(hEvent,INFINITE);
		switch(ireq)
		{
		case 0:		// close
			iend = 0;
			break;
		case 1:		// out & close
			strcopy(moji,smoji);
			rs_puts(hCom,moji);
			iend = 0;
			break;
		case 2:		// out & in
			strcopy(moji,smoji);
			rs_puts(hCom,moji);
		case 3:		// in
			cnt = total(men_h,m_moto,m_saki,m_naru,tesu,kifu);
			if (cnt)
			{
				rs_gets(hCom,moji);
				if (strncmp(moji,"%TORYO",6) == 0)
				{
					::PostMessage((HWND)pParam,WM_SASITE,0,-1);
				}
				else if (strncmp(moji,"%MATTA",6) == 0)
		        {
					::PostMessage((HWND)pParam,WM_SASITE,0,-2);
		        }
				else if (strncmp(moji,"%CHUDAN",7) == 0)
		        {
					::PostMessage((HWND)pParam,WM_SASITE,0,-3);
		        }
				else if (strncmp(moji,"%HIKIWAKE",9) == 0)
				{
					::PostMessage((HWND)pParam,WM_SASITE,0,-4);
				}
				else if (strncmp(moji,"%KACHI",6) == 0)
				{
					::PostMessage((HWND)pParam,WM_SASITE,0,-5);
				}
				else
				{
					/* 1 moji-me */
					moto = 0;
					switch(moji[1])
					{
					case '0':
						ix_old = 0;
						break;
					case '1':
						ix_old = 1;
						break;
					case '2':
						ix_old = 2;
						break;
					case '3':
						ix_old = 3;
						break;
					case '4':
						ix_old = 4;
						break;
					case '5':
						ix_old = 5;
						break;
					case '6':
						ix_old = 6;
						break;
					case '7':
						ix_old = 7;
						break;
					case '8':
						ix_old = 8;
						break;
					case '9':
						ix_old = 9;
						break;
					default:
						moto = -1;
						break;
					}
					/* 2moji-me */
					switch(moji[2])
					{
					case '0':
						iy_old = 0;
						break;
					case '1':
						iy_old = 1;
						break;
					case '2':
						iy_old = 2;
						break;
					case '3':
						iy_old = 3;
						break;
					case '4':
						iy_old = 4;
						break;
					case '5':
						iy_old = 5;
						break;
					case '6':
						iy_old = 6;
						break;
					case '7':
						iy_old = 7;
						break;
					case '8':
						iy_old = 8;
						break;
					case '9':
						iy_old = 9;
						break;
					default:
						moto = -1;
						break;
					}
					if (moto == 0)moto = ix_old + (iy_old - 1) * 9;
					/* 3 moji-me */
					saki = 0;
					switch(moji[3])
					{
					case '1':
						ix_new = 1;
						break;
					case '2':
						ix_new = 2;
						break;
					case '3':
						ix_new = 3;
						break;
					case '4':
						ix_new = 4;
						break;
					case '5':
						ix_new = 5;
						break;
					case '6':
						ix_new = 6;
						break;
					case '7':
						ix_new = 7;
						break;
					case '8':
						ix_new = 8;
						break;
					case '9':
						ix_new = 9;
						break;
					default:
						saki = -1;
						break;
					}
					/* 4moji-me */
					switch(moji[4])
					{
					case '1':
						iy_new = 1;
						break;
					case '2':
						iy_new = 2;
						break;
					case '3':
						iy_new = 3;
						break;
					case '4':
						iy_new = 4;
						break;
					case '5':
						iy_new = 5;
						break;
					case '6':
						iy_new = 6;
						break;
					case '7':
						iy_new = 7;
						break;
					case '8':
						iy_new = 8;
						break;
					case '9':
						iy_new = 9;
						break;
					default:
						saki = -1;
						break;
					}
					if (saki == 0)saki = ix_new + (iy_new - 1) * 9;
					/* 5 & 6 moji-me */
					koma = 0;
					for (i = 0 ; i < 15; i++)
					{
						if (strncmp(&moji[5],koma_kind[i],2) == 0)
						{
							koma = i + 1;
							break;
						}
					}
					if (moto == -9)
					{
						moto = koma + UCHI_KOMA;
						naru = 0;
					}
					else
					{
						koma_old = men_h[moto];
						if (koma_old < 0)koma_old = -koma_old;
						if (koma_old == koma)
						{
							naru = 0;
						}
						else
						{
							naru = 1;
						}
					}
					kotae = 1;
					for (i = 0 ; i < cnt ; i++)
					{
						if (saki != m_saki[i])continue;
						if (moto != m_moto[i])continue;
						if (moto < UCHI_KOMA)
						{
							if (naru != m_naru[i])continue;
						}
						if (naru)
						{
							saki += NARU_CODE;
						}
						kotae = 0;
						break;
					}
					if (kotae)
					{
						moto = 0;
						saki = -6;
						strcopy(rs_message,moji);
					}
					::PostMessage((HWND)pParam,WM_SASITE,moto,saki);
				}
			}
			else
			{
				iend = 0;
			}
		default:
			break;
		}
		if (chudan_flag)break;
	}
	CloseHandle(hEvent);
	hEvent = NULL;
	CloseHandle(hCom);
	com_name[0] = 0;

	return(0);
}

/*****************/
/* RS232C  */
/*****************/

void rs_init(int *i_man,HWND m_hWnd,CString	m_comname)
{
	int		i;

	rs_message[0] = 0;
	com_name  [0] = 0;

	hEvent = NULL;
	ireq   = 0;
	for (i = 0 ; i < 2 ; i++)
	{
		if (i_man[i] == -1)
		{
			strcpy_s(com_name,m_comname);
			hEvent = CreateEvent(NULL,FALSE,FALSE,NULL);
			AfxBeginThread(Rs232cThreadProc,m_hWnd,THREAD_PRIORITY_NORMAL);
			break;
		}
	}
}

void rs_send(int teban,int moto,int saki,char *men)
{
	int		koma;
	int		id;
	char	moji[12];

    koma = men[saki];
	if (teban)
	{
		koma    = -koma;
		moji[0] = '-';
	}
	else
	{
		moji[0] = '+';
    }
	if (moto > UCHI_KOMA)
	{
		moji[1] = moji[2] = '0';
	}
	else
	{
		sprintf_s(&moji[1],3,"%d%d" ,(moto - 1) % 9 + 1
								,(moto - 1) / 9 + 1);
	}
	sprintf_s(&moji[3],3,"%d%d" ,(saki - 1) % 9 + 1
							,(saki - 1) / 9 + 1);
	sprintf_s(&moji[5],4,"%s\n",koma_kind[koma - 1]);
	id = 1 - teban;
	if (hEvent)
	{
		strcopy(smoji,moji);
		ireq = 2;
		SetEvent(hEvent);
	}
}

void rs_kick()
{
	if (hEvent)
	{
		ireq = 3;
		SetEvent(hEvent);
	}
}

void rs_close(void)
{
	if (com_name[0])
	{
		if (ireq != 1)
		{
			ireq = 0;
			if (hEvent)
			{
				SetEvent(hEvent);
			}
		}
		com_name[0] = 0;
	}
}

void rs_last_out(int i_code)
{
	if (hEvent)
	{
		switch(i_code)
		{
		case -1:				/*  */
			strcopy(smoji,"%TORYO\n");
			ireq = 1;
			SetEvent(hEvent);
			break;
		case -2:				/* ҂ */
			strcopy(smoji,"%MATTA\n");
			ireq = 1;
			SetEvent(hEvent);
            break;
		case -3:				/* f */
			strcopy(smoji,"%CHUDAN\n");
			ireq = 1;
			SetEvent(hEvent);
            break;
		case -4:				/* 錾 */
			strcopy(smoji,"%HIKIWAKE\n");
			ireq = 1;
			SetEvent(hEvent);
            break;
		case -5:				/* 錾 */
			strcopy(smoji,"%KACHI\n");
			ireq = 1;
			SetEvent(hEvent);
			break;
		default:
			ireq = 0;
			SetEvent(hEvent);
			break;
		}
	}
}
