/************************/
/*    SikoudllDlg.cpp   */
/************************/
#include "stdafx.h"
#include "Oki.h"
#include "SikoudllDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

/////////////////////////////////////////////////////////////////////////////
// CSikoudllDlg _CAO

IMPLEMENT_DYNAMIC(CSikoudllDlg,CDialog)

CSikoudllDlg::CSikoudllDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSikoudllDlg::IDD, pParent)
{
	m_dll      = _T("");
	m_joseki   = _T("");
	m_tachiage = _T("");
	m_ini      = _T("");
	m_sikou    = _T("");
	m_ura      = _T("");
	m_end      = _T("");
}

void CSikoudllDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);

	DDX_Text(pDX, IDC_EDIT_DLL, m_dll);
	DDV_MaxChars(pDX, m_dll, 255);
	DDX_Text(pDX, IDC_EDIT_JOSEKI, m_joseki);
	DDV_MaxChars(pDX, m_joseki, 255);
	DDX_Text(pDX, IDC_EDIT_TACHIAGE, m_tachiage);
	DDX_Text(pDX, IDC_EDIT_INI, m_ini);
	DDX_Text(pDX, IDC_EDIT_SIKOU, m_sikou);
	DDX_Text(pDX, IDC_EDIT_URA, m_ura);
	DDX_Text(pDX, IDC_EDIT_END, m_end);
}

BEGIN_MESSAGE_MAP(CSikoudllDlg, CDialog)
	ON_BN_CLICKED(IDC_BUTTON_DLL, OnButtonDll)
	ON_BN_CLICKED(IDC_BUTTON_JOSEKI, OnButtonJoseki)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSikoudllDlg bZ[W nh

void CSikoudllDlg::OnButtonDll()
{
	if (!UpdateData(TRUE))return;

	CFileDialog		dlg(TRUE,"dll",m_dll,OFN_FILEMUSTEXIST | OFN_HIDEREADONLY,
					"DLL FILES (*.dll)|*.dll|ALL FILES(*.*)|*.*||",NULL);

	dlg.m_ofn.lpstrTitle = "SET vl DLL";

	if (dlg.DoModal() == IDOK)
	{
		m_dll = dlg.GetPathName();
		UpdateData(FALSE);
	}
}

void CSikoudllDlg::OnButtonJoseki() 
{
	if (!UpdateData(TRUE))return;

	CFileDialog		dlg(TRUE,"mix",m_joseki,OFN_FILEMUSTEXIST | OFN_HIDEREADONLY,
					"Rt@C(*.mix)|*.mix|Ճt@C(*.jsk)|*.jsk|ALL FILES(*.*)|*.*||",NULL);

	dlg.m_ofn.lpstrTitle = "SET Ճt@C";

	if (dlg.DoModal() == IDOK)
	{
		m_joseki = dlg.GetPathName();
		UpdateData(FALSE);
	}
}
