/************************/
/*       clip.cpp       */
/************************/
#include "stdafx.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

extern void strcopy(char *s1,char *s2);

static int	ip;
static char	*cbuf;

/************************************
/* Nbv{[hI[vB	*/
/************************************/

int	clip_open()
{
	int		len;
	HGLOBAL	hMem;
	LPSTR	lpMem;

	OpenClipboard(NULL);
	hMem = GetClipboardData(CF_TEXT);
	if (hMem)
	{
		lpMem = (char *)GlobalLock(hMem);
		len   = strlen(lpMem);
		cbuf  = (char *)malloc(len + 1);
		strcopy(cbuf,lpMem);
		GlobalUnlock(hMem);
		ip = 0;
	}
	else
	{
		len = 0;
	}
	CloseClipboard();

	return(len);
}

/************************************
/* Nbv{[hN[YB	*/
/************************************/

int clip_gets(char *buf,int len)
{
	int		i;
	char	c;

	len--;
	i = 0;
	c = cbuf[ip];

	while(c)
	{
		switch(c)
		{
		case 0x0a:
			buf[i++] = c;
			buf[i  ] = 0;
			ip++;
			return(i);
		case 0x0d:
			if (cbuf[ip + 1] == 0x0a)
			{
				break;
			}
		default:
			buf[i++] = c;
			break;
		}

		ip++;
		if (i >= len)break;
		c = cbuf[ip];
	}

	buf[i] = 0;

	return(i);
}

/************************************
/* Nbv{[hN[YB	*/
/************************************/

void clip_close(void)
{
	free(cbuf);
}

/********************************************/
/* Nbv{[h̃ItZbg𒲐B	*/
/********************************************/

void clip_offset(int offset)
{
	ip = offset;
}

