/************************/
/*     sictotal.cpp     */
/************************/
#include "stdafx.h"
#include "sente.h"

char amari[]  = { 0 , 0 , 1 , 2 , 3 , 4 , 5 , 6 , 7 , 8 ,
                      0 , 1 , 2 , 3 , 4 , 5 , 6 , 7 , 8 ,
                      0 , 1 , 2 , 3 , 4 , 5 , 6 , 7 , 8 ,
                      0 , 1 , 2 , 3 , 4 , 5 , 6 , 7 , 8 ,
                      0 , 1 , 2 , 3 , 4 , 5 , 6 , 7 , 8 ,
                      0 , 1 , 2 , 3 , 4 , 5 , 6 , 7 , 8 ,
                      0 , 1 , 2 , 3 , 4 , 5 , 6 , 7 , 8 ,
                      0 , 1 , 2 , 3 , 4 , 5 , 6 , 7 , 8 ,
                      0 , 1 , 2 , 3 , 4 , 5 , 6 , 7 , 8 };

static char kiki_mae    [] = { 0x00,0x01,-127,0x00,0x01,0x01,0x00,-127,0x01,
                                    0x01,0x01,0x01,0x01,0x00,0x01,-127 };
static char kiki_maex   [] = { 0x00,0x00,0x00,0x00,0x01,0x01,-127,0x00,0x01,
                                    0x01,0x01,0x01,0x01,0x00,-127,0x01 };
static char kiki_yoko   [] = { 0x00,0x00,0x00,0x00,0x00,0x01,0x00,-127,0x01,
                                    0x01,0x01,0x01,0x01,0x00,0x01,-127 };
static char kiki_ushirox[] = { 0x00,0x00,0x00,0x00,0x01,0x00,-127,0x00,0x01,
                                    0x00,0x00,0x00,0x00,0x00,-127,0x01 };

static int sub_s(int koma,int moto,int saki,int cnt,int *m_moto,int *m_naru)
{
	m_moto[cnt] = moto;
	switch(koma)
	{
	case SFU:
		if (saki > 27)
		{
			m_naru[cnt++] = 0;
		}
		else
		{
			m_naru[cnt++] = 1;
        }
        break;
	case SKYO:
	case SKEI:
		if (saki > 27)
		{
			m_naru[cnt++] = 0;
		}
		else
		{
            m_naru[cnt++] = 1;
			if (saki <= 18)break;
			m_moto[cnt  ] = moto;
			m_naru[cnt++] = 0;
        }
        break;
    case SGIN:
		m_naru[cnt++] = 0;
		if (moto <= 27)
        {
            m_moto[cnt  ] = moto;
			m_naru[cnt++] = 1;
        }
		else if (saki <= 27)
        {
            m_moto[cnt  ] = moto;
			m_naru[cnt++] = 1;
        }
		break;
	case SKAKU:
	case SHI:
		if (moto <= 27)
		{
			m_naru[cnt++] = 1;
		}
		else if (saki <= 27)
		{
			m_naru[cnt++] = 1;
		}
		else
		{
			m_naru[cnt++] = 0;
		}
		break;
    default:
        m_naru[cnt++] = 0;
		break;
    }
	return(cnt);
}

/*******************************************************/
/* ̂̈ʒuɂ𐶐郋[`  D  */
/*******************************************************/
int	sictotal(char *men,int saki,int *m_moto,int *m_naru)
{
	int		cnt;
	int		ix;
	int		ix_save;
	int		moto;
	int		koma;

	cnt = 0;
	ix  = ix_save = amari[saki];

	if (saki <= 72)
    {
        while(1)
        {
            moto  = saki + 9;
            koma = men[moto];
            if (koma < 0)break;
            if (koma > 0)
            {
                if (kiki_mae[koma])
				{
					cnt = sub_s(koma,moto,saki,cnt,m_moto,m_naru);
				}
                break;
            }
            while(moto <= 72)
            {
                moto += 9;
                koma = men[moto];
                if (koma < 0)break;
                if (koma > 0)
                {
                    if (kiki_mae[koma] < 0)
					{
						cnt = sub_s(koma,moto,saki,cnt,m_moto,m_naru);
					}
                    break;
                }
            }
            break;
        }

        while(ix < 8)
        {
            moto  = saki + 10;
            koma = men[moto];
            if (koma < 0)break;
            if (koma > 0)
            {
                if (kiki_maex[koma])
				{
					cnt = sub_s(koma,moto,saki,cnt,m_moto,m_naru);
				}
				break;
			}
            ix++;
            while(moto <= 72)
            {
                if (ix == 8)break;
                moto += 10;
                koma = men[moto];
                if (koma < 0)break;
                if (koma > 0)
                {
                    if (kiki_maex[koma] < 0)
					{
						cnt = sub_s(koma,moto,saki,cnt,m_moto,m_naru);
					}
                    break;
                }
                ix++;
            }
            break;
        }
        ix = ix_save;

        while(ix > 0)
        {
            moto  = saki + 8;
            koma = men[moto];
            if (koma < 0)break;
            if (koma > 0)
            {
                if (kiki_maex[koma])
				{
					cnt = sub_s(koma,moto,saki,cnt,m_moto,m_naru);
				}
				break;
			}
			ix--;
            while(moto <= 72)
            {
                if (ix == 0)break;
                moto += 8;
                koma = men[moto];
                if (koma < 0)break;
                if (koma > 0)
                {
                    if (kiki_maex[koma] < 0)
					{
						cnt = sub_s(koma,moto,saki,cnt,m_moto,m_naru);
					}
                    break;
                }
                ix--;
            }
            break;
        }
        ix = ix_save;
    }

    if (saki <= 63)
    {
        if (ix)
        {
            moto = saki + 17;
            if (men[moto] == SKEI)
			{
				cnt = sub_s(SKEI,moto,saki,cnt,m_moto,m_naru);
			}
        }
        if (ix != 8)
        {
            moto = saki + 19;
            if (men[moto] == SKEI)
			{
				cnt = sub_s(SKEI,moto,saki,cnt,m_moto,m_naru);
			}
        }
    }

    while(ix < 8)
    {
        moto  = saki + 1;
        koma = men[moto];
        if (koma < 0)break;
        if (koma > 0)
        {
            if (kiki_yoko[koma])
			{
				cnt = sub_s(koma,moto,saki,cnt,m_moto,m_naru);
			}
            break;
        }
        ix++;
        while(ix < 8)
        {
            moto++;
            koma = men[moto];
            if (koma < 0)break;
            if (koma > 0)
            {
				if (kiki_yoko[koma] < 0)
				{
					cnt = sub_s(koma,moto,saki,cnt,m_moto,m_naru);
				}
				break;
			}
			ix++;
        }
        break;
    }
    ix = ix_save;

    while(ix > 0)
    {
        moto  = saki - 1;
        koma = men[moto];
        if (koma < 0)break;
        if (koma > 0)
        {
            if (kiki_yoko[koma])
			{
				cnt = sub_s(koma,moto,saki,cnt,m_moto,m_naru);
			}
            break;
        }
        ix--;
        while(ix > 0)
        {
            if (ix == 0)break;
            moto--;
            koma = men[moto];
            if (koma < 0)break;
            if (koma > 0)
            {
                if (kiki_yoko[koma] < 0)
				{
					cnt = sub_s(koma,moto,saki,cnt,m_moto,m_naru);
				}
                break;
            }
            ix--;
        }
        break;
    }
    ix = ix_save;

    if (saki >= 10)
    {
        while(ix < 8)
        {
            moto  = saki - 8;
            koma = men[moto];
            if (koma < 0)break;
            if (koma > 0)
            {
                if (kiki_ushirox[koma])
				{
					cnt = sub_s(koma,moto,saki,cnt,m_moto,m_naru);
				}
                break;
            }
            ix++;
            while(moto >= 10)
            {
                if (ix == 8)break;
                moto -= 8;
                koma = men[moto];
                if (koma < 0)break;
                if (koma > 0)
                {
                    if (kiki_ushirox[koma] < 0)
					{
						cnt = sub_s(koma,moto,saki,cnt,m_moto,m_naru);
					}
					break;
                }
                ix++;
            }
            break;
        }
        ix = ix_save;

        while(ix > 0)
        {
            moto  = saki - 10;
            koma = men[moto];
            if (koma < 0)break;
            if (koma > 0)
            {
                if (kiki_ushirox[koma])
				{
					cnt = sub_s(koma,moto,saki,cnt,m_moto,m_naru);
				}
				break;
            }
            ix--;
            while(moto >= 10)
            {
                if (ix == 0)break;
                moto -= 10;
                koma = men[moto];
                if (koma < 0)break;
                if (koma > 0)
                {
                    if (kiki_ushirox[koma] < 0)
					{
						cnt = sub_s(koma,moto,saki,cnt,m_moto,m_naru);
					}
                    break;
                }
                ix--;
            }
            break;
        }

        while(1)
        {
            moto  = saki - 9;
            koma = men[moto];
            if (koma < 0)break;
            if (koma > 0)
            {
                if (kiki_yoko[koma])
				{
					cnt = sub_s(koma,moto,saki,cnt,m_moto,m_naru);
				}
                break;
            }
            while(moto >= 10)
            {
                moto -= 9;
                koma = men[moto];
                if (koma < 0)break;
                if (koma > 0)
                {
                    if (kiki_yoko[koma] < 0)
					{
						cnt = sub_s(koma,moto,saki,cnt,m_moto,m_naru);
					}
                    break;
                }
            }
            break;
        }
    }
    return(cnt);
}

static int sub_g(int koma,int moto,int saki,int cnt,int *m_moto,int *m_naru)
{
	m_moto[cnt] = moto;
    switch(koma)
    {
    case SFU:
        if (saki <= 54)
        {
            m_naru[cnt++] = 0;
        }
        else
        {
			m_naru[cnt++] = 1;
        }
        break;
    case SKYO:
	case SKEI:
        if (saki <= 54)
        {
            m_naru[cnt++] = 0;
        }
        else
        {
            m_naru[cnt++] = 1;
            if (saki > 63)break;
            m_moto[cnt  ] = moto;
			m_naru[cnt++] = 0;
        }
        break;
	case SGIN:
		m_naru[cnt++] = 0;
        if (moto > 54)
        {
            m_moto[cnt  ] = moto;
            m_naru[cnt++] = 1;
        }
		else if (saki > 54)
        {
            m_moto[cnt  ] = moto;
            m_naru[cnt++] = 1;
        }
		break;
    case SKAKU:
    case SHI:
        if (saki > 54)
        {
            m_naru[cnt++] = 1;
        }
        else if (moto > 54)
        {
            m_naru[cnt++] = 1;
        }
        else
        {
            m_naru[cnt++] = 0;
        }
        break;
    default:
		m_naru[cnt++] = 0;
		break;
	}
	return(cnt);
}

/*******************************************************/
/* ̂̈ʒuɂ𐶐郋[`  D  */
/*******************************************************/
int gictotal(char *men,int saki,int *m_moto,int *m_naru)
{
	int		moto;
	int		koma;
	int		cnt;
    int     ix;
    int     ix_save;

	cnt  = 0;

    ix = ix_save = amari[saki];

    if (saki >= 10)
    {
        while(1)
        {
            moto = saki - 9;
            koma = -men[moto];
            if (koma < 0)break;
            if (koma > 0)
            {
                if (kiki_mae[koma])
				{
					cnt = sub_g(koma,moto,saki,cnt,m_moto,m_naru);
				}
                break;
            }
            while(moto >= 10)
            {
                moto -= 9;
                koma = -men[moto];
                if (koma < 0)break;
                if (koma > 0)
                {
                    if (kiki_mae[koma] < 0)
					{
						cnt = sub_g(koma,moto,saki,cnt,m_moto,m_naru);
					}
                    break;
                }
            }
            break;
        }

        while(ix < 8)
        {
            moto  = saki - 8;
            koma = -men[moto];
            if (koma < 0)break;
            if (koma > 0)
            {
                if (kiki_maex[koma])
				{
					cnt = sub_g(koma,moto,saki,cnt,m_moto,m_naru);
				}
                break;
            }
            ix++;
            while(moto >= 10)
            {
                if (ix == 8)break;
                moto -= 8;
                koma = -men[moto];
                if (koma < 0)break;
                if (koma > 0)
                {
                    if (kiki_maex[koma] < 0)
					{
						cnt = sub_g(koma,moto,saki,cnt,m_moto,m_naru);
					}
                    break;
                }
                ix++;
            }
            ix = ix_save;
            break;
        }

        while(ix > 0)
        {
            moto  = saki - 10;
            koma = -men[moto];
            if (koma < 0)break;
            if (koma > 0)
            {
                if (kiki_maex[koma])
				{
					cnt = sub_g(koma,moto,saki,cnt,m_moto,m_naru);
				}
                break;
            }
            ix--;
            while(moto >= 10)
            {
                if (ix == 0)break;
                moto -= 10;
                koma = -men[moto];
                if (koma < 0)break;
                if (koma > 0)
                {
                    if (kiki_maex[koma] < 0)
					{
						cnt = sub_g(koma,moto,saki,cnt,m_moto,m_naru);
					}
                    break;
                }
                ix--;
            }
            ix = ix_save;
            break;
        }
    }

    if (saki > 18)
    {
        if (ix)
        {
            moto = saki - 19;
            if (men[moto] == GKEI)
			{
				cnt = sub_g(SKEI,moto,saki,cnt,m_moto,m_naru);
			}
        }
        if (ix != 8)
        {
            moto = saki - 17;
            if (men[moto] == GKEI)
			{
				cnt = sub_g(SKEI,moto,saki,cnt,m_moto,m_naru);
			}
        }
    }

    while(ix < 8)
    {
        moto  = saki + 1;
        koma = -men[moto];
        if (koma < 0)break;
        if (koma > 0)
        {
            if (kiki_yoko[koma])
			{
				cnt = sub_g(koma,moto,saki,cnt,m_moto,m_naru);
			}
            break;
        }
        ix++;
        while(ix < 8)
        {
            moto++;
            koma = -men[moto];
            if (koma < 0)break;
            if (koma > 0)
            {
                if (kiki_yoko[koma] < 0)
				{
					cnt = sub_g(koma,moto,saki,cnt,m_moto,m_naru);
				}
                break;
            }
            ix++;
        }
        ix = ix_save;
        break;
    }

    while(ix > 0)
    {
        moto  = saki - 1;
        koma = -men[moto];
        if (koma < 0)break;
        if (koma > 0)
        {
            if (kiki_yoko[koma])
			{
				cnt = sub_g(koma,moto,saki,cnt,m_moto,m_naru);
			}
            break;
        }
        ix--;
        while(ix > 0)
        {
            if (ix == 0)break;
            moto--;
            koma = -men[moto];
            if (koma < 0)break;
            if (koma > 0)
            {
                if (kiki_yoko[koma] < 0)
				{
					cnt = sub_g(koma,moto,saki,cnt,m_moto,m_naru);
				}
                break;
            }
            ix--;
        }
        ix = ix_save;
        break;
    }

    if (saki <= 72)
    {
        while(ix < 8)
        {
            moto  = saki + 10;
            koma = -men[moto];
            if (koma < 0)break;
            if (koma > 0)
            {
                if (kiki_ushirox[koma])
				{
					cnt = sub_g(koma,moto,saki,cnt,m_moto,m_naru);
				}
                break;
            }
            ix++;
            while(moto <= 72)
            {
                if (ix == 8)break;
                moto += 10;
                koma = -men[moto];
                if (koma < 0)break;
                if (koma > 0)
                {
                    if (kiki_ushirox[koma] < 0)
					{
						cnt = sub_g(koma,moto,saki,cnt,m_moto,m_naru);
					}
                    break;
                }
                ix++;
            }
            ix = ix_save;
            break;
        }

        while(ix > 0)
        {
            moto  = saki + 8;
            koma = -men[moto];
            if (koma < 0)break;
            if (koma > 0)
            {
                if (kiki_ushirox[koma])
				{
					cnt = sub_g(koma,moto,saki,cnt,m_moto,m_naru);
				}
                break;
            }
            ix--;
            while(moto <= 72)
            {
                if (ix == 0)break;
                moto += 8;
                koma = -men[moto];
                if (koma < 0)break;
                if (koma > 0)
                {
                    if (kiki_ushirox[koma] < 0)
					{
						cnt = sub_g(koma,moto,saki,cnt,m_moto,m_naru);
					}
                    break;
                }
                ix--;
            }
            break;
        }

        while(1)
        {
            moto = saki + 9;
            koma = -men[moto];
            if (koma < 0)break;
            if (koma > 0)
            {
                if (kiki_yoko[koma])
				{
					cnt = sub_g(koma,moto,saki,cnt,m_moto,m_naru);
				}
                break;
            }
            while(moto <= 72)
            {
                moto += 9;
                koma = -men[moto];
                if (koma < 0)break;
                if (koma > 0)
                {
                    if (kiki_yoko[koma] < 0)
					{
						cnt = sub_g(koma,moto,saki,cnt,m_moto,m_naru);
					}
                    break;
                }
            }
            break;
        }
    }
    return(cnt);
}
